#!/bin/sh

DN=$(cd "${0%/*}" && pwd)

unset APA_VER CONF_FILE APACHE_STOP

while getopts c:v:r:i: c ; do
  case $c in
    c) CONF_FILE=$OPTARG ;;
    v) APA_VER=$OPTARG ;;
    r) APACHE_STOP=$OPTARG ;;
    i) INITIAL_VERSION=$OPTARG ;;
  esac
done

INITIAL_VERSION=`expr $INITIAL_VERSION + 0 2>/dev/null`
[ ${#INITIAL_VERSION} -gt 18 ] && INITIAL_VERSION=0

grep -q '^APACHE_CONF=.*/' "$CONF_FILE" 2>/dev/null || exit 0
ls "$DN"/limit_httpd.conf "$DN"/StoreClosed.html >/dev/null || exit 1

EPWEB=${EPAGES_WEBGROUP%%:*}
EPWEB=${EPWEB:-epages}
[ -n "${APA_VER#.}" ] && SUFFIX=-$APA_VER-$INITIAL_VERSION || SUFFIX=-$INITIAL_VERSION

export OFS=$IFS

[ "$(egrep -v '^[[:space:]]*(#|$)' "$DN"/limit_httpd.conf | wc -l)" -eq 0 ] && exit 0

if [ ! -d "$HTTPD_ROOT"/icons ] ; then
  mkdir -m 750 -p "$HTTPD_ROOT"/icons
  chgrp $EPWEB "$HTTPD_ROOT"/icons
fi
if [ ! -f "$HTTPD_ROOT"/icons/StoreClosed.html ] ; then
  cp -p "$DN"/StoreClosed.html "$HTTPD_ROOT"/icons
  chgrp $EPWEB "$HTTPD_ROOT"/icons/StoreClosed.html
  if [ -w /etc/passwd ] ; then
    chown ep_web "$HTTPD_ROOT"/icons "$HTTPD_ROOT"/icons/StoreClosed.html
  fi
fi

IFS='\\'
for i in `awk -F= '/^APACHE_CONF=/{print $2}' < $CONF_FILE` ; do
  grep -q "limit_httpd" "$i" && continue
  [ -f "$i".unlimited$SUFFIX ] || cp -p "$i" "$i".unlimited$SUFFIX
  cp -p "$i" "$i".unlimited$APA_VER
  [ ! -w /etc/passwd ] && chgrp $EPWEB "$i".unlimited{$APA_VER,$SUFFIX}

  ( IFS=$OFS ; echo ; echo "# limit_httpd" ; echo
    for j in "$EPAGES_WEBROOT" "$EPAGES/WebAdapter" ; do
      echo "<Directory '$j'>" ; echo "Order deny,allow"
      echo "ErrorDocument 403 /icons_closed/StoreClosed.html"
      echo "Deny from all" ; cat "$DN"/limit_httpd.conf ; echo "</Directory>"
    done
    echo "Alias /icons_closed/  \"$HTTPD_ROOT/icons/\""
    echo "<Directory $HTTPD_ROOT/icons>" ; echo "Order allow,deny"
    echo "Allow from all" ; echo "</Directory>"
  ) >> "$i" || exit 1
done

exit 0
