#!/bin/sh
DN=$(cd "${0%/*}" && pwd)
CWD=`pwd`

unset APA_VER CONF_FILE APACHE_STOP

while getopts c:v:r:i: c ; do
  case $c in
    c) CONF_FILE=$OPTARG ;;
    v) APA_VER=$OPTARG ;;
    r) APACHE_STOP=$OPTARG ;;
    i) INITIAL_VERSION=$OPTARG ;;
  esac
done

INITIAL_VERSION=`expr $INITIAL_VERSION + 0 2>/dev/null`
[ ${#INITIAL_VERSION} -gt 18 ] && INITIAL_VERSION=0

grep -q '^APACHE_CONF=.*/' "$CONF_FILE" 2>/dev/null || exit 0

EPWEB=${EPAGES_WEBGROUP%%:*}
EPWEB=${EPWEB:-epages}
[ -n "${APA_VER#.}" ] && SUFFIX=-$APA_VER-$INITIAL_VERSION || SUFFIX=-$INITIAL_VERSION

APACHE_CONF_DIR=`awk '/^APACHE_CONF_DIR=../{sub(/APACHE_CONF_DIR=/,"");print}' < "$CONF_FILE"`
APACHE_LOCAL=`awk '/^APACHE_LOCAL=./{sub(/APACHE_CONF_DIR=/,"");print}' < "$CONF_FILE"`
EPAGES_APAVER=`awk '/^EPAGES_APAVER=./{sub(/EPAGES_APAVER=\\$/,"");print}' < "$CONF_FILE"`
EPAGES_REWRITE_CONF=`awk '/^EPAGES_REWRITE_CONF=./{sub(/EPAGES_REWRITE_CONF=\\$/,"");print}' < "$CONF_FILE"`
EPAGES_WEBSRV=${EPAGES_REWRITE_CONF#\$}
[ "${EPAGES_WEBSRV#HTTPD_ROOT/}" = "$EPAGES_WEBSRV" ] && unset EPAGES_WEBSRV || EPAGES_REWRITE_CONF=`eval echo $EPAGES_REWRITE_CONF`

export OFS=$IFS
IFS='\\'
for i in `awk -F= '/^APACHE_CONF=/{print $2}' < $CONF_FILE` ; do
 if [ -f "$i".unlimited. ] ; then
    cat "$i".unlimited. > "$i"
  elif [ ! -f "$i".unlimit. ] ; then
    /bin/cp -p "$i" "$i".unlimit.
  fi
done
IFS=$OFS

cd $CWD

if [ -n "$APACHE_CONF_DIR" -a "$APA_VER" = new ] ; then

  # postinstall

  if [ $INITIAL_VERSION -lt 6000007000 -a -s "$APACHE_LOCAL" ] ; then
    i=$APACHE_LOCAL
    if grep -q '^[[:space:]]*\.[[:space:]]\+/etc/default/"\?'"$EPAGES_PROJECT"'\b' "$i" 2>/dev/null && ! grep -q update-rewrite-conf.sh "$i" ; then
      sed -n '1,/^\s*\.\s\+\/etc\/default\/"\?'"$EPAGES_PROJECT"'\b/p' "$i" > "$i.~$$~"
      echo '[ -x "$EPAGES"/bin/update-rewrite-conf.sh ] && "$EPAGES"/bin/update-rewrite-conf.sh' >> "$i.~$$~"
      comm -23  "$i" "$i.~$$~" >> "$i.~$$~"
      [ -f "$i"$SUFFIX ] || /bin/cp -p "$i" "$i"$SUFFIX
      cat "$i.~$$~" > "$i"
      /bin/rm -f "$i.~$$~"
    fi
    if [ -f /etc/sysconfig/${i##*/} ] ; then
      ( . /etc/sysconfig/${i##*/}
        [ -z "$APACHE_MODULES" ] && exit 0
        am=" $APACHE_MODULES "
        [ "${am/ rewrite /}" = "$am" ] || exit 0
        [ -f /etc/sysconfig/${i##*/}$SUFFIX ] || /bin/cp -p /etc/sysconfig/${i##*/} /etc/sysconfig/${i##*/}$SUFFIX
        /bin/cp -p /etc/sysconfig/${i##*/} /etc/sysconfig/${i##*/}.~$$~
        sed 's,^\([[:space:]]*APACHE_MODULES=\).*,\1"'"$APACHE_MODULES rewrite"'",' /etc/sysconfig/${i##*/}.~$$~ > /etc/sysconfig/${i##*/}
        /bin/rm -f /etc/sysconfig/${i##*/}.~$$~
      )
    fi
  fi

fi

[ -n "$APACHE_CONF_DIR" ] && find "$APACHE_CONF_DIR" -name '*~'$$'~*' -exec /bin/rm \-f {} \;

exit 0
