dojo.provide("epages.cartridges.de_epages.content.widget.TagInlineEditor");
dojo.require('epages.cartridges.de_epages.content.widget.TagEditor');
dojo.require('epages.cartridges.de_epages.presentation.widget.InlineEditor');

dojo.declare(
	"epages.cartridges.de_epages.content.widget.TagInlineEditor",
	[epages.cartridges.de_epages.presentation.widget.InlineEditor],
	{

		availableTags:	'',

		show: function() {
			// TagEditor
			if (!this.isInited) {
				this.object = new epages.cartridges.de_epages.content.widget.TagEditor({
					presetTags: this.availableTags,
					value: this.value,
					name: this.inputName,
					group: 'epages.cartridges.de_epages.content.widget.TagEditor'
				}, this.contentNode);
				this.contentNode = this.object.textbox;
				dojo.connect(this.object.domNode, 'onblur', this, 'hide');
				this._copyStyle(this.object.textbox, this._computedStyle);
				// reset color of input text
				this.contentNode.style.color = '';
				if (this.undoObject) this.undoObject.registerInput(this.contentNode);
				dojo.connect(this.contentNode, 'onkeyup', this, 'onChangeContentNode');
				dojo.connect(this.contentNode, 'onpaste', this, 'onChangeContentNode');
				this.isInited = true;
			}
			this.displayNode.style.display = 'none';
			this.contentNode.style.display = '';
			this.contentNode.focus();
			this.inherited("show", arguments);
		},

		hide: function() {
			if(this.object){
				this.object.hide();
			}
			if (!this.isInited) return;
			if (this.contentNode.value == '') {
				this.displayNode.innerHTML = this._placeHolderText;
			} else {
				this.displayNode.innerHTML = this.contentNode.value;
			}
			this.displayNode.style.display = '';
			this.contentNode.style.display = 'none';
			this.inherited("hide", arguments);
		},

		onChangeContentNode: function() {
			this.displayNode.innerHTML = this.object.getValue();
			this.inherited("onChangeContentNode", arguments);
		}

	}
);
