dojo.provide('epages.cartridges.de_epages.design.widget.NavigationelementLogo');
dojo.require('epages.cartridges.de_epages.design.widget.Navigationelement');
dojo.require('epages.cartridges.de_epages.mediagallery.widget.Filebrowser');

dojo.declare(
	"epages.cartridges.de_epages.design.widget.NavigationelementLogo",
	[epages.cartridges.de_epages.design.widget.Navigationelement],
	{

	initEditDialog : function() {
	//summary: initalize widgets in dialog / subscribe to topics
		this.inherited("initEditDialog", arguments);
		top.dojo.subscribe('LogoDialogFilebrowser'+this.objectId+'Filelist/select', function(/* FileListItem */ item) {
		// publish generalized message (for use of more than one logo widget)
			dojo.publish("LogoDialogFilebrowserFilelist/select", [item]);
		});

		// subscribe to generalized message
		dojo.subscribe("LogoDialogFilebrowserFilelist/select", this, 'synchronizeLogo');

		// cut away media gallery path
		var filenameNode = top.$('LogoDialogName'+this.objectId);
		var filename = filenameNode.innerHTML;
		filename = filename.replace(/MediaGallery\//, "");
		filenameNode.innerHTML=filename;
	},

	synchronizeLogo : function(/* FileListItem */item) {
	// summary: update logo preview widget, logoname and filesize in dialog
		if(item.fullpath.match("MediaGallery")) {       // only Mediagallery files / skip image db
			var logoPrev = top.$$('LogoDialogPreview'+this.objectId);
			logoPrev.addImage({ image: item.fullpath }, true);

			var lnNode = top.$('LogoDialogName'+this.objectId);
			dojo.addClass(lnNode, "Bold");
			lnNode.innerHTML = item.name;

			var liNode = top.$('LogoDialogInfo'+this.objectId);
			liNode.innerHTML ="("+item.imagewidth + " x "+item.imageheight+" / "+item.size+")";

			var inpNode = top.$('LogoDialogNameInput'+this.objectId);
			inpNode.value=item.fullpath;

			var mNode = top.$('LogoDialogOnApplyMessage'+this.objectId);
			mNode.style.display="";
		}
	},

	onbeforePreview: function(/* domnode */ inputNode) {
	// summary: shows busylayer before the logo got modified
	// domnode: input node that has changed in dialog
		this.inherited("onbeforePreview", arguments);

		var name = inputNode.name;

		if(name.match("Logo")) { // logo name node was changed
			top.dojo.publish("uimessage/startBusy", ["logoPreviewupdate", this.translate("UpdatingLogoPreview"), epages.theme.url+'/images/ico_l_design.png']);

			// do request to generate new logo
			var value = inputNode.value;
			value = value.replace(epages.vars.SiteRoot+'/', "");
			dojo.require('epages.io.json');
			var json = new epages.io.Json();

			var result = json.loadSync(this.url, {
				'ChangeAction' : 'SaveLogo',
				'Logo'         : value,
				'ObjectID'     : epages.vars.SiteID,
				'ViewAction'   : 'JSONViewResponse'
			});

			// modify node value (all logos used in style object are named as logo.<old extension>)
			var splitArr = value.split(".");
			var ext = undefined;
			if(splitArr.length) {
				ext = splitArr[splitArr.length-1];
			}

			if(ext) {
				inputNode.value=top.epages.vars.EditorStyleWebPath+'/logo.'+ext;
			}

			if(! top.epages.vars.EditorStyleWebPath) {
				console.warn("top.epages.vars.EditorStyleWebPath not defined in "+this.declaredClass);
			}
		}
	},

	setPreview: function(evt) {
	// summary: update preview for all logo navelements (onchange: input node)
			var el = evt.target;																					// get input node
			var node = $('eid_' + el.name, this.domNode.ownerDocument);		// get target node

			if(node) {
				var value = el.value == '' ? this.emptyString : el.value;		// get value;
				var NavigationElements = dojo.query('.NavigationElementWidget');
				var logoWidget = undefined;

				for(var i = 0; i < NavigationElements.length;i++){
					var navElWidget = $$(NavigationElements[i].id);
					var ShopLogoNodes = dojo.query('.ShopLogo',navElWidget.contentNode);   // has logo?
					if(ShopLogoNodes.length != 0) {
						navElWidget.setLogo(value);

						// reset all filebrowser widgets (open root folder)
						var fileBrowser = top.$$('LogoDialogFilebrowser'+navElWidget.objectId);
						if(fileBrowser) {
							fileBrowser.openRootFolder();
						}

					}
				}
			} else {
				console.warn("node '%s' not found, possible not in template ("+this.declaredClass+")", 'eid_' + el.name);
			}
			top.dojo.publish("uimessage/stopBusy", ["logoPreviewupdate", 1500]);
		},

		setLogo : function(/* string */ value) {
		// summary: set src attribute of logo node
			var logoNode = $('eid_'+this.objectId+':Logo:'+this.languageId);
			if(logoNode) {
				var date = new Date();
				logoNode.src=value+'?CachePrevention='+date.getTime();
			} else {
				console.warn('logo node not found in '+this.declaredClass);
			}
		}

});
