/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.cssfix $Revision: 1.8.2.1 $

*/
dojo.provide("epages.cssfix");
dojo.require('epages.epages');
dojo.require('epages.browser');

epages.cssfix = {

	png: {

		minImageSize: 24,

		replaceImages: function () {
			for(var i = 0; i < document.images.length; i++) {
				if(	document.images[i].src &&
						document.images[i].src.match('.png') &&
						!document.images[i].className.match("AlphaImage") &&
						!document.images[i].className.match("NoAlphaImage") &&
						!document.images[i].src.match(/\x28/) &&									/* ( */
						document.images[i].offsetWidth >= this.minImageSize &&
						document.images[i].offsetHeight >= this.minImageSize &&
						document.images[i].complete) {
					var computedStyles = dojo.getComputedStyle(document.images[i]);
					with(document.images[i].style){
						zoom = "1";
						width = (document.images[i].offsetWidth ? document.images[i].offsetWidth - parseInt(computedStyles.paddingLeft) - parseInt(computedStyles.paddingRight) : this.minImageSize) + "px";
						height = (document.images[i].offsetHeight ? document.images[i].offsetHeight - parseInt(computedStyles.paddingTop) - parseInt(computedStyles.paddingBottom) : this.minImageSize) + "px";
						if(computedStyles.margin == "0px") {margin = computedStyles.padding}
						filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src=" + document.images[i].src + ", sizingMethod='scale')";
					}
					document.images[i].src = epages.vars.IconsRoot + "/general_img_transparentpixel.gif";
					// for all images changed by js
					dojo.connect(document.images[i], "onload", function(evt) {
						if(!evt.currentTarget.src.match("general_img_transparentpixel.gif")) {
							evt.currentTarget.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src=" + evt.currentTarget.src + ", sizingMethod='scale')"
							evt.currentTarget.src = epages.vars.IconsRoot + "/general_img_transparentpixel.gif";
						}
					});
					// since we don't want to affect the startup performance
					// we only filter one image at a time...with a certain delay
					setTimeout(function(){epages.cssfix.png.replaceImages()}, 40);
					break;
				}
			}
		},
		init: function() {
			dojo.addOnLoad(function(){if(epages.Browser.engine == "MSIE") {epages.cssfix.png.replaceImages()}});
		}
	},

// =======================================================================================================

	pseudoclasses: {

		NODEDEPTH: 12, // increase this value if the depth is insufficient for your needs (this has an insignificant performance impact)

		hoverTriggerClasses: ["EnableHover", "TreeContent", "Command"],
		// TODO: actually "EnableHover" is the only class which has the right to be listed in here
		activeTriggerClasses: ["EnableActive"],
		focusTriggerClasses: ["EnableFocus"],

		lastHoveredNode: dojo.body(),
		currentHoveredNodes: [],

		mouseMoved: false,

		_lastSelectSelected: null,
		_lastFocusedNode: null,

		_registerFocus: function() {
			// summary: handling focus for form elements (to serve the focus() method on these elements)
			var domNodes = dojo.query("input").concat(dojo.query("textarea")).concat(dojo.query("select"));
			for(var i = 0; i < domNodes.length; i++) {
				if(!domNodes[i].focusHandle) {
					domNodes[i].focusHandle = true;
					dojo.connect(domNodes[i], "focus", this, function(evt) {
						evt.currentTarget.setAttribute("focused", "");
						if(epages.Browser.engine == "MSIE") {
							dojo.addClass(evt.currentTarget, "focused");
						}
					});
					dojo.connect(domNodes[i], "blur", this, function(evt) {
						evt.currentTarget.removeAttribute("focused");
						if(epages.Browser.engine == "MSIE") {
							dojo.removeClass(evt.currentTarget, "focused");
						}
					});
				}
			}
		},

		_checkFocus: function(evt) {
			// summary: handling focus
			if(evt.target.disabled || (evt.target.className && evt.target.className.match("Disabled"))) {return}
			if(this._lastFocusedNode) {
				this._lastFocusedNode.removeAttribute("focused");
				if(epages.Browser.engine == "MSIE") {
					dojo.removeClass(this._lastFocusedNode, "focused");
				}
			}
			var focusTriggerClass = false;
			for(var z = 0; z < this.focusTriggerClasses.length; z++) {
				if(evt.target.className && evt.target.className.match(this.focusTriggerClasses[z])) {
					focusTriggerClass = true;
				}
			}
			if(focusTriggerClass
				|| evt.target.tagName == "A"
				|| evt.target.tagName == "INPUT"
				|| evt.target.tagName == "TEXTAREA"
				|| evt.target.tagName == "SELECT") {
				evt.target.setAttribute("focused", "");
				if(epages.Browser.engine == "MSIE") {
					dojo.addClass(evt.target, "focused");
				}
				this._lastFocusedNode = evt.target;
			}

			//this emulates the focus css status on select form elements for IE
			if(evt.target.tagName === "SELECT" && epages.Browser.engine == "MSIE") {
				evt.target.parentNode.setAttribute("focused", "");
				dojo.addClass(evt.target.parentNode, "focused");
				this._lastFocusedNode = evt.target.parentNode;
			}
		},

		_removeActive: function(evt) {
			evt.currentTarget.removeAttribute("activated", "");
			if(epages.Browser.engine == "MSIE") {
				dojo.removeClass(evt.currentTarget, "activated");
			}
		},

		update: function() {

			if(this.lastHoveredNode) {

				var currentNode = this.lastHoveredNode;
				for(var i = 0; i < this.NODEDEPTH; i++) {
					if(currentNode) {
						var cssClass = currentNode.className || "";

						// handling :hover
						var hoverTriggerClass = false;
						for(var z = 0; z < this.hoverTriggerClasses.length; z++) {
							if(typeof cssClass == "string" && cssClass.match(this.hoverTriggerClasses[z])) {
								hoverTriggerClass = true;
							}
						}
						if((hoverTriggerClass
							|| (currentNode.parentNode && currentNode.parentNode.parentNode && currentNode.parentNode.parentNode.className && currentNode.parentNode.parentNode.className.match("ContentList") && currentNode.tagName == "TR")
							|| currentNode.tagName == "A"
							|| currentNode.tagName == "INPUT"
							|| currentNode.tagName == "TEXTAREA"
							|| currentNode.tagName == "SELECT")
							&& !currentNode.disabled) {
							if(!currentNode.isHovered) {
								this.currentHoveredNodes.push(currentNode);
								currentNode.setAttribute("hovered", "");
								if(epages.Browser.engine == "MSIE") {
									dojo.addClass(currentNode, "hovered");
								}
							}
							currentNode.isHovered = true;
							currentNode.removeHover = false;
						}

						//handling :active (no need to listen to this when hover is not fired yet)
						var activeTriggerClass = false;
						for(var z = 0; z < this.activeTriggerClasses.length; z++) {
							if(typeof cssClass == "string" && cssClass.match(this.activeTriggerClasses[z])) {
								activeTriggerClass = true;
							}
						}
						if(activeTriggerClass || currentNode.tagName == "A" && !currentNode.activeHandle) {
							currentNode.activeHandle = true;
							dojo.connect(currentNode, "mousedown", this, function(evt) {
								evt.currentTarget.setAttribute("activated", "");
								if(epages.Browser.engine == "MSIE") {
									dojo.addClass(evt.currentTarget, "activated");
								}
							});
							dojo.connect(currentNode, "mouseup", this, "_removeActive");
							dojo.connect(currentNode, "mouseleave", this, "_removeActive");
						}

						if(currentNode.tagName != "BODY" && currentNode.tagName != "HTML") {
							currentNode = currentNode.parentNode;
						}else {
							break;
						}
					}
				}

				var cleanedHoveredNodes = [];

				for(var i = 0; i < this.currentHoveredNodes.length; i++) {
					if(this.currentHoveredNodes[i].removeHover) {
						this.currentHoveredNodes[i].removeAttribute("hovered");
						if(epages.Browser.engine == "MSIE") {
							dojo.removeClass(this.currentHoveredNodes[i], "hovered");
						}
						this.currentHoveredNodes[i].isHovered = false;
					}else {
						cleanedHoveredNodes.push(this.currentHoveredNodes[i]);
					}
					this.currentHoveredNodes[i].removeHover = true;
				}

				this.currentHoveredNodes = cleanedHoveredNodes;

			}
		},

		init: function() {

			dojo.connect(dojo.body(), "mouseover", dojo.hitch(this, function(evt) {
				this.lastHoveredNode = evt.target;
				this.mouseMoved = true;
			}));
			dojo.connect(dojo.body(), "mouseleave", dojo.hitch(this, function(evt) {
				this.lastHoveredNode = evt.currentTarget;
				this.mouseMoved = true;
			}));

			dojo.connect(dojo.body(), "mouseup", dojo.hitch(this, function(evt) {
				this._checkFocus(evt);
			}));
			dojo.connect(dojo.body(), "keyup", dojo.hitch(this, function(evt) {
				if(evt.keyCode == dojo.keys.TAB) {
					this._checkFocus(evt);
				}
			}));

			dojo.addOnLoad(dojo.hitch(this, "update"));
			dojo.addOnLoad(dojo.hitch(this, "_registerFocus"));

			setInterval(dojo.hitch(this, function() {
				if(this.mouseMoved) {
					this.update();
					this.mouseMoved = false;
				}
			}), 1);
		}
	},

// =======================================================================================================

	updatestyles: {

		_refreshNode: null,

		update: function (evt) {
			if(dojo.query(".GeneralLayout", dojo.body())[0] || (evt && (evt.target.tagName == "SELECT" || evt.target.tagName == "OPTION" || evt.target.tagName == "TEXTAREA" || evt.target.tagName == "INPUT" || evt.target.tagName == "OBJECT"))) {return}
			this._refreshNode.style.height = "100%";
			setTimeout(dojo.hitch(this, function() {
				this._refreshNode.style.height = "auto";
			}), 1);
		},
		init: function() {
			if(epages.Browser.engine == "WebKit") {
				this._refreshNode = $("Content") || dojo.body().parentNode;
				dojo.connect(dojo.body().parentNode, "click", this, "update");
				dojo.addOnLoad(dojo.hitch(this, function(){
					dojo.hitch(this, "update");
				}));
			}
		}
	},

// =======================================================================================================

	highlighterrorimages: {
		init: function() {
			dojo.addOnLoad(function() {
				for(var i = 0; i < document.images.length; i++) {
					var tmpTestImage = new Image();
					tmpTestImage.onerror = function() {
						this.imageRef.src = epages.themeUrl('images') + "/img_faultyimage.png";
					}
					tmpTestImage.imageRef = document.images[i];
					tmpTestImage.src = document.images[i].src;
				}
			});
		}
	},

// =======================================================================================================

	hideemptylistitems: {
		init: function() {
			dojo.addOnLoad(function() {
				if(epages.Browser.engine == "MSIE") {
					var listItems = dojo.query("li");
					for(var i = 0; i < listItems.length; i++) {
						var innerNodes = listItems[i].getElementsByTagName("*");
						var realNodes = 0;
						var fakedNodes = 0;
						for(var k = 0; k < innerNodes.length; k++) {
							if(innerNodes[k].nodeType != 8) {
								realNodes++;
								break;
								return;
							}else {
								fakedNodes++;
							}
						}
						if((realNodes < 1 && listItems[i].innerHTML.match("<--")) || (fakedNodes < 1 && realNodes < 1 && listItems[i].innerHTML.length < 2)) {
							dojo.addClass(listItems[i], "HideElement");
						}
					}
				}
			});
		}
	},

// =======================================================================================================

	init: function() {
		this.png.init(); // fix blurry png images in IE
		this.pseudoclasses.init(); // add enhanced pseudoclass support to IE
		this.updatestyles.init(); // force lazy WebKit to really update the page after a click
		this.highlighterrorimages.init(); // highlight faulty images
		this.hideemptylistitems.init(); // hide empty list items (<li></li>) in IE
	}
}

dojo.addOnLoad(dojo.hitch(epages.cssfix, epages.cssfix.init));