/* ---------------------------------------------------------------------------------------------------
	 ePages 5 - epages_scripts.js $Revision: 1.13.2.1 $
	 --------------------------------------------------------------------------------------------------- */
dojo.provide('epages.epages_scripts');
dojo.require('epages.epages');
dojo.require('epages.html');
dojo.require('dojo.fx');

/* - General Functions ------------------------------------------------------------------------------- */

window.openWindow = function (URL, windowName, features, PathToStoreFront) {
	if (PathToStoreFront === null) PathToStoreFront = undefined; // old fashion
	if(features=="PopUp") {
		features="width=1000, height=730, toolbar=no, status=no, resizable=yes, menubar=no, location=no, scrollbars=yes";
	}
	if(features=="PopUpPrint") {
		features="width=790, height=580, toolbar=yes, status=no, resizable=yes, menubar=yes, location=no, scrollbars=yes";
	}
	if(features=="RTE" || windowName=="RTE") {
		features="width=996, height=700, toolbar=no, status=no, resizable=yes, menubar=no, location=no, scrollbars=yes";
	}
	if(features=="HelpWindow") {
		features="width=1000, height=730, toolbar=no, status=no, resizable=yes, menubar=no, location=no, scrollbars=yes";
		windowName="WWHFrame";
	 }
	if(features=="StylePreview") {
		features="width=470, height=310, toolbar=no, status=no, resizable=no, menubar=no, location=no, scrollbars=no";
		windowName="StylePreview";
	 }
	if(features=="DetailedImageView") {
		features="width=1000, height=730, toolbar=no, status=no, resizable=yes, menubar=no, location=no, scrollbars=yes";
		windowName="StylePreview";
	 }
	if(features=="CheckLink") {
		if(URL.indexOf("?") != 0) {
			splittedString = URL.split('//');
			if(splittedString.length ==1){
				URL ="http://"+URL;
			}
		} else if(PathToStoreFront!=undefined){
				URL = PathToStoreFront+URL;
		}
		features="toolbar=yes, status=yes, resizable=yes, menubar=yes, location=yes, scrollbars=yes";
	}

	if(URL != "http://") {
		var newwin=window.open(URL,windowName,features);
		if(newwin)
			newwin.focus();
	}

	return newwin;
};

window.linkCorrection = function (oInputField) {
// summary: inserts http protocol if there is no protocol
	var Value=oInputField.value;
	var splittedString = Value.split('//');
	if(Value.indexOf("?") != 0) {
		if(splittedString.length == 1){
			oInputField.value ="http://"+Value;
			epages.event.fire(oInputField, "change");
		}
	}
};

window.OnCheckAll = function (form, name, checked, /* boolean? */ skipFireEvent) {
//summary: used to mark all check boxes in a list as "checked"
		dojo.addClass(form.getElementsByTagName("tbody")[0], "HideElement");
		for(var i=0; i<form.length; i++) {
			var input = form[i];
			if(input.nodeName == 'INPUT') {
				if((input.type == 'checkbox' || input.className.match("Checkbox")) && input.name == name && !input.disabled && input.checked != checked) {
					input.checked = checked;
					if(!skipFireEvent) {
						// we need that for the ContentList widget (row selection)
						if($$(input.id)) {
							$$(input.id).setChecked(checked);
						}
						if(checked) {
							dojo.addClass(input.parentNode.parentNode, "RowSelected");
						}else {
							dojo.removeClass(input.parentNode.parentNode, "RowSelected");
						}
					}
				}
			}
		}
		dojo.removeClass(form.getElementsByTagName("tbody")[0], "HideElement");
};

window.DeactivateButton = function (Button) {
// summary: function to disable an input field
// Button must be an input/button object
		if(Button.className.match("CustomButton")) {
				fakeButton = Button.getElementsByTagName("*")[0];
				fakeButton.disabled="true";
				dojo.addClass(Button, "Disabled");
		}
		else if(Button.getAttribute('widgetid')){
			$$(Button.getAttribute('widgetid')).disable();
		}
		else {
				Button.disabled="true";
				dojo.addClass(Button, "Disabled");
		}
};

window.EnableButton = function (Button) {
// summary: function to enable an input field
// Button must be an input/button object
		if(Button.className.match("CustomButton")) {
				fakeButton = Button.getElementsByTagName("*")[0];
				fakeButton.disabled="false";
		}
		else if(Button.getAttribute('widgetid')){
			$$(Button.getAttribute('widgetid')).enable();
		}
		else {
				Button.disabled="false";
		}
		dojo.removeClass(Button, "Disabled");
};

window.DisableLink = function (Link) {
	// summary: function to disable a link
	if($(Link)) {
		$(Link).className += ' Opacity40';
		$(Link).href = 'javascript:void(0)';
		$(Link).style.cursor = 'default';
	}
};


window.changeImage = function (ImageID, ImageURL, ImageTitle) {
// summary: changes the image url & title of an image element (specified by its id attribute)
	$(ImageID).src = ImageURL;
	if (ImageTitle) {
		$(ImageID).alt = ImageTitle;
	}
};

window.OptionToChangeAction = function (select) {
	select.form.ChangeAction.value = select.options[select.selectedIndex].value;
};

window.toggleTopic = function(/* dom node */ el, /* string? */ label1, /* string? */ label2) {
	if(el.parentNode) {
		var className = el.parentNode.className;
		if(className.match("Closed")) {
			epages.html.replaceClass(el.parentNode, "Open", "Closed");
		} else {
			epages.html.replaceClass(el.parentNode, "Closed", "Open");
		}
		if(label1 && label2) {
			if(el.innerHTML == label1) {
				el.innerHTML = label2;
			} else {
				el.innerHTML = label1;
			}
		}
	}
};

window.toggleDisplay = function (elementId) {
// summary: switches the display properties of an element (specified by its id attribute)
// by changing the class name (HideElement / ShowElement)
	if ($(elementId).className != 'HideElement') {
		$(elementId).className = 'HideElement';
	} else {
		$(elementId).className = 'ShowElement';
	}
};

window.hideElement = function (elementId) {
		if(!$(elementId).className.match(/HideElement/)) $(elementId).className += ' HideElement';
};

window.showElement = function (elementId) {
		$(elementId).className=$(elementId).className.replace(/HideElement/,"");
};

window.changeDataById = function (newdata, id) {
	myobject = $(id);
	if(myobject.firstChild) {
		myobject.firstChild.data = newdata;
	} else {
		mydata = document.createTextNode(newdata);
		myobject.appendChild(mydata);
	}
};

window.getSelectedData = function (selectElement) {
// summary: scans all option tags in a select tag to find the data of the selected item
	if(selectElement) {
		myNode= selectElement.firstChild;
		while (myNode!=null) {
			if(myNode.value==selectElement.value && myNode.value!="") {
				return myNode.firstChild.data;
			}
			myNode = myNode.nextSibling;
		}
		return "";
	}
};

window.checkBrowser = function () {
	 var userAgent = navigator.userAgent.toLowerCase();
	 this.isIE = (userAgent.indexOf('msie') != -1);
	 this.isGecko = (userAgent.indexOf('gecko') != -1 && userAgent.indexOf('safari') == -1);
	 this.isOpera = (userAgent.indexOf('opera') != -1);
	 this.isRTECompatible= (this.isIE || this.isGecko);
};

var browser = new checkBrowser();

window.disableFormFieldsInElement = function (ElementId) {
// summary: disables all form fields that are sub elements of a given ElementId
	userattrinputs = $(ElementId).getElementsByTagName("input");
	for(i=0; i < userattrinputs.length; i++) {
		userattrinputs[i].disabled=true;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className += " Disabled";
		}
		if(userattrinputs[i].type != 'checkbox' && userattrinputs[i].type != 'radio') {
				if(userattrinputs[i].type == "button" || userattrinputs[i].type == "submit") {
					userattrinputs[i].parentNode.className = userattrinputs[i].parentNode.className + " Disabled";
				}else{
					userattrinputs[i].className=userattrinputs[i].className+" Disabled";
				}
		}
	}
	userattrtextareas = $(ElementId).getElementsByTagName("textarea");
	for(i=0; i < userattrtextareas.length; i++) {
		userattrtextareas[i].disabled=true;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className += " Disabled";
		}
		userattrtextareas[i].className=userattrtextareas[i].className+" Disabled";
	}
	userattrselects = $(ElementId).getElementsByTagName("select");
	for(i=0; i < userattrselects.length; i++) {
		userattrselects[i].disabled=true;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className += " Disabled";
		}
		userattrselects[i].className=userattrselects[i].className+" Disabled";
	}
};

window.enableFormFieldsInElement = function (ElementId) {
// summary: enables all form fields that are sub elements of a given ElementId
	userattrinputs = $(ElementId).getElementsByTagName("input");
	for(i=0; i < userattrinputs.length; i++) {
		userattrinputs[i].disabled=false;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className = $(ElementId).parentNode.className.replace(/Disabled/g, "");
		}
		userattrinputs[i].parentNode.className=userattrinputs[i].parentNode.className.replace(/ Disabled/,"");
		userattrinputs[i].parentNode.className=userattrinputs[i].parentNode.className.replace(/Disabled/,"");
		userattrinputs[i].className=userattrinputs[i].className.replace(/ Disabled/,"");
		userattrinputs[i].className=userattrinputs[i].className.replace(/Disabled/,"");
	}
	userattrtextareas = $(ElementId).getElementsByTagName("textarea");
	for(i=0; i < userattrtextareas.length; i++) {
		userattrtextareas[i].disabled=false;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className = $(ElementId).parentNode.className.replace(/Disabled/g, "");
		}
		userattrtextareas[i].className=userattrtextareas[i].className.replace(/ Disabled/,"");
		userattrtextareas[i].className=userattrtextareas[i].className.replace(/Disabled/,"");
	}
	userattrselects = $(ElementId).getElementsByTagName("select");
	for(i=0; i < userattrselects.length; i++) {
		userattrselects[i].disabled=false;
		if($(ElementId).parentNode.className.match("Cropper")) {
			 $(ElementId).parentNode.className = $(ElementId).parentNode.className.replace(/Disabled/g, "");
		}
		userattrselects[i].className=userattrselects[i].className.replace(/ Disabled/,"");
		userattrselects[i].className=userattrselects[i].className.replace(/Disabled/,"");
	}
};

window.disableFormFieldById = function (ElementId) {
// summary: function to disable an input field specified by id
	var NeedDisabledClass=true;
	if(disableFormFieldById.arguments.length>1)NeedDisabledClass=disableFormFieldById.arguments[1];
	$(ElementId).disabled=true;
	if($(ElementId).parentNode.className.match("Cropper")) {
		 $(ElementId).parentNode.className += " Disabled";
	}
	if(NeedDisabledClass) {
		dojo.addClass($(ElementId), "Disabled");
	}
};

window.enableFormFieldById = function (ElementId) {
// summary: function to enable an input field specified by id
	var NeedDisabledClass=true;
	if(enableFormFieldById.arguments.length>1)NeedDisabledClass=enableFormFieldById.arguments[1];
	$(ElementId).disabled=false;
	if($(ElementId).parentNode.className.match("Cropper")) {
		 $(ElementId).parentNode.className = $(ElementId).parentNode.className.replace(/Disabled/g, "");
	}
	if(NeedDisabledClass) {
		dojo.removeClass($(ElementId), "Disabled");
	}
};

window.allowURLUpload = function () {
// description: 
//  requires
//   id "FileUpload" on the file upload input field
//   id "FileUpload2" on a hidden input field
	var FileUploadValue=$('FileUpload').value;
	if(FileUploadValue.match(/http:../)||FileUploadValue.match(/https:../)){
		$('FileUpload2').value=FileUploadValue;
		$('FileUpload2').disabled=false;
		$('FileUpload').disabled=true;
	}
};

window.allowBulkURLUpload = function (ElementName) {
// description:
// all inputs of type file need a second hidden input for urls (initial disabled)
// - both elements must have the same name eg. name="Filename"
// - the id of the file upload element must look like this: id="FileName<ItemNo>"
// - the id of the hidden input must look like this: id="URLUpload<ItemNo>"

		var aryElements=document.getElementsByName(ElementName);
		for(var i=0; i < aryElements.length; i++) {
				var FileUploadValue=aryElements[i].value;
				var ElementType=aryElements[i].type;
				var FileUploadID=aryElements[i].id;
				if((FileUploadValue.match(/http:../)||FileUploadValue.match(/https:../)) && ElementType != "hidden"){
						$(FileUploadID.replace(/FileName/,"URLUpload")).value=FileUploadValue;
						$(FileUploadID.replace(/FileName/,"URLUpload")).disabled=false;
						$(FileUploadID).disabled=true;
				}
		}
};


window.setValue = function (Value, TargetID) {
		$(TargetID).value=Value;
};

/* - Special Functions ------------------------------------------------------------------------------- */

window.autofillAddress = function (/*Object*/changedObject) {
// summary: this function fills out the "DisplayName" input field (name="DisplayName") automatically
// changedObject: object with the "changed" data --> CustomerGeneral.TabPage
	changedObject.form.DisplayName.value=changedObject.form.FirstName.value + ' ' + changedObject.form.LastName.value;
	if( changedObject.form.UserAlias ) {
		changedObject.form.UserAlias.value=changedObject.form.FirstName.value.slice(0,1) + changedObject.form.LastName.value;
	}
	if( changedObject.form.UserName ) {
		changedObject.form.UserName.value=changedObject.form.FirstName.value + ' ' + changedObject.form.LastName.value;
	}
};

window.SFautofillAddress = function (FirstNameId, LastNameId, DisplayNameId) {
// summary: fills out the "DisplayName" input field (name="DisplayName") automatically
	$(DisplayNameId).value=$(FirstNameId).value + ' ' + $(LastNameId).value;
};

window.setCurrentDate = function (currentDate, targetInputFieldID) {
// summary: changes the value of an input field to the current date
	$(targetInputFieldID).value=currentDate;
};

window.updateStyleSheetRule = function (rule, text) {
	// summary:
	//    add a CSS rule with given text.
	// example:
	//    googleUpdateStyleSheetRule('.NavBarTop div, .NavBarTop span', 'padding-left: 5px');
	text += ' !important';
	if (browser.isIE) {
		var rules = rule.split(/,\s+/);
		var sheet = document.styleSheets[document.styleSheets.length-1];
		for(var i=0; i< rules.length; i++) {
			sheet.addRule(rules[i], text);
		}
	} else {
		var sheets = document.getElementsByTagName('style');
		sheet = sheets[sheets.length-1];
		sheet.innerHTML += '\n' + rule + '{' + text + ';}';
	}
};

window.showNotAllowedDialog = function(domNode, message) {
	dojo["require"]("epages.uimessagehandler");
	dojo.require("epages.html.element");

	var position = $E(domNode).getAbsolutePosition();
	var screenW = document.getElementsByTagName("body")[0].clientWidth;
	var screenH = document.getElementsByTagName("body")[0].clientHeight;
	var orientation = 'top';
	var xoff = 0;
	var yoff = 0;

	if(position.x > (screenW / 2)) {
		orientation = 'right';
	}

	if(position.y > (screenH - 30)) {
		orientation = 'bottom';
		yoff = 0;
		xoff = 0;
	}

	if (orientation=='top') {
		xoff = 10;
		yoff = domNode.offsetHeight;
	}

	if(orientation == 'right' || orientation == 'left') {
		yoff = domNode.offsetHeight / 2;
	}

	dojo.publish("uimessage/show", ["", message, "Bubble", {
		typeClass: "Warning Wide",
		sizeClass: "Medium",
		x: position.x + xoff,
		y: position.y + yoff,
		orientation: orientation
	}]);
	dojo.connect(dojo.body(), "mouseup", this, function() {
		dojo.publish("uimessage/hide");
	});
};

/* - Dialog Area ------------------------------------------------------------------------------------ */
window.DialogArea = function () {
// summary: is used as constructor for an DialogArea-Object
	this.areaName = new Array();
	this.areaId = new Array();
	this.areaDisplayName = new Array();
	this.areaActivated = new Array();          // false = area disabled    ; true = area is a activated

	this.addArea = function(areaName, areaId) {
	//  this function is used to register the areas in a dialog
		this.areaName.push(areaName);
		this.areaId.push(areaId);
		if(this.addArea.arguments.length>3) {
			this.areaDisplayName.push(this.addArea.arguments[2]);
			this.areaActivated.push(this.addArea.arguments[3]);
		} else {
			this.areaDisplayName.push("");
			this.areaActivated.push(true);
		}
	};

	this.createAreaLinks = function() {
			for(var i=0; i<this.areaName.length; i++) {
					var oAreaLink;
					if(this.areaActivated[i]) {
							oAreaLink=document.createElement("a");
							oAreaLink.href="javascript:epagesDialog.toggleArea('"+this.areaName[i]+"');";
							oAreaLink.name=this.areaName[i];
							oAreaLink.id=this.areaName[i];
							oAreaLink.className="HideArea";
					} else {
							oAreaLink=document.createElement("span");
							oAreaLink.name=this.areaName[i];
							oAreaLink.id=this.areaName[i];
							oAreaLink.className="disabled";
					}
					var oLinkText=document.createTextNode(this.areaDisplayName[i]);
					oAreaLink.appendChild(oLinkText);
					$("ToggleTabpageArea").appendChild(oAreaLink);
			}
	};

	this.showArea = function(areaName) {
	// summary: used to show an Area
		areaId="";
	// search for the AreaName in the epagesDialog Object
		for(i=0; i < this.areaName.length; i++) {
			if(this.areaName[i] == areaName) areaId = this.areaId[i];
		}
		try {
				dojo.removeClass(document.getElementsByName(areaName)[0], "HideArea");
				dojo.addClass(document.getElementsByName(areaName)[0], "ShowArea");
		} catch(ex) {
				dojo.removeClass($(areaName), "HideArea");
				dojo.addClass($(areaName), "ShowArea");
		}
		$(areaId).className='ShowElement';
		if(browser.isIE) {
				// workaround silly MSIE display errors (elements with position:relative are still hidden after setting them visible)
				setTimeout("$('"+areaId+"').className='ShowElement';", 10);
		}
		actualDialogArea = areaName;
	};

	this.hideArea = function(areaName) {
	// summary: used to show an Area
		areaId="";
	// search for the AreaName in the epagesDialog Object
		for(i=0; i < this.areaName.length; i++) {
			if(this.areaName[i] == areaName) areaId = this.areaId[i];
		}
		dojo.removeClass(document.getElementsByName(areaName)[0], "ShowArea");
		dojo.addClass(document.getElementsByName(areaName)[0], "HideArea");
		$(areaId).className='HideElement';
		actualDialogArea = "";
	};

	this.toggleArea = function(areaName) {
	//  summary: used to toggle the view of an area
	//  and to hide all unselected areas
		this.showArea(areaName);

	// loop through all dialog areas and hide them
		for(i=0; i<this.areaName.length; i++) {
			tempName=this.areaName[i]; tempId=this.areaId[i];
			if(areaName != tempName) {
				if(this.areaActivated[i]) {
						dojo.removeClass(document.getElementsByName(tempName)[0], "ShowArea");
						dojo.addClass(document.getElementsByName(tempName)[0], "HideArea");
						$(tempId).className = 'HideElement';
				}
			}
		}
	};

	this.toggleAreaDisplay = function(areaName) {
	// summary: used to toggle the view of the specified area
	// display settings of other areas remain
		if(document.getElementsByName(areaName)[0].className.match('HideArea')) {
			this.showArea(areaName);
		} else {
			this.hideArea(areaName);
		}
	};

	this.selectArea = function(areaName) {
	// summary: used to show the selected area
	//  and to hide all the other areas
		this.showArea(areaName);
	// loop through all dialog areas and hide them
		for(i=0; i<this.areaName.length; i++) {
			tempName=this.areaName[i]; tempId=this.areaId[i];
			if(areaName != tempName) {
				dojo.removeClass(document.getElementsByName(tempName)[0], "ShowArea");
				dojo.addClass(document.getElementsByName(tempName)[0], "HideArea");
				$(tempId).className = 'HideElement';
			}
		}
	};
};

window.appendDialogArea = function (formElement) {
	if(actualDialogArea!="") {
		formElement.action += "&DialogArea="+actualDialogArea;
	}
};

actualDialogArea = "";
epagesDialog = new DialogArea();

/* - Switch Wizard Pages ----------------------------------------------------------------------------- */
window.WizardPages = function () {
	// summary: constructor for wizard pages
	this.TabId = new Array();
	this.AreaId = new Array();

	this.addPage = function(TabId, AreaId) {
		this.TabId.push(TabId);
		this.AreaId.push(AreaId);
	};

	this.showStep = function(Index) {
	// summary: used to show the selected page of the wizard
		ActualWizardPage=Index;

		window.scrollTo(0,0);

		// change tab
		$(this.TabId[Index]).className="selected";
		$(this.TabId[Index]).getElementsByTagName("span")[0].firstChild.className="selected";
		try{$(this.TabId[Index]).getElementsByTagName("span")[0].appendChild(oHelpTopic);} catch(ex) { }
		$(this.AreaId[Index]).className="ShowElement";
		for(i=0; i<this.TabId.length; i++) {
			if(i != Index) {
				$(this.TabId[i]).className="unselected";
				$(this.TabId[i]).getElementsByTagName("span")[0].firstChild.className="disabled";
				$(this.AreaId[i]).className = 'HideElement';
			}
		}
	};
};

ActualWizardPage = 0;
WizardPages= new WizardPages();

/* - our "lightbox" ----------------------------------------------------------------------------- */

window.showImage = function(image) {
	dojo.require("epages.widget.Slides");
	(new epages.widget.Slides).openOverview(image);
};


/* - showMore / showLess -- */

	window.showMore = function(alias, refNode) {
		// summary: wipe in hidden node / hide reference node (clicked node)if specified
		if(refNode) {
			refNode.style.display='none';
		}
		dojo.fx.wipeIn({ node: $(alias),  duration: 200}).play();
	};
	window.showLess = function(alias) {
		// summary: wipe out hidden node
		dojo.fx.wipeOut({ node: $(alias), duration: 200}).play();
	};