/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.event.interactionrestrictor $Revision: 1.4.2.2 $

*/
dojo.provide("epages.event.interactionrestrictor");
dojo.require("epages.html.element");
dojo.require("epages.loaderani");

epages.event.interactionRestrictor = function(/*Object?*/ position) {
	// summary: busylayer for a specific dom element
	// position: specifies an alternative position where the overlay is displayed 
	// example:
	//  | dojo.publish("interactionRestrictor/suspend", ["layerId", domNode, (hideLayer)]);
	//  | dojo.publish("interactionRestrictor/permit", ["layerId"]);

	dojo.subscribe("interactionRestrictor/suspend", function(layerId, domNode, hideLayer,position) {
		if(!$(layerId) && domNode && domNode.offsetWidth) {
			dojo.body().className += " SuspendUserInteraction";
			var suspendAnimation = document.createElement("div");
			if(!position){
				var suspendPosition = new epages.html.Element(domNode).getAbsolutePosition(dojo.body());
				var position = {
					Width  : domNode.offsetWidth,
					Height : domNode.offsetHeight,
					Left   : suspendPosition.x,
					Top    : suspendPosition.y
				}
			}
			with(suspendAnimation) {
				id = layerId;
				className = "SuspendUserInteractionAnimation";
				style.width = position.Width + "px";
				style.height = position.Height + "px";
				style.left = position.Left + "px";
				style.top = position.Top + "px";
				style.zIndex = 11000;
			}
			if(hideLayer) {
				dojo.addClass(suspendAnimation, "SuspendUserInteractionHidden");
			}else if(domNode.offsetHeight > 0) {
				suspendAnimation.loaderani = epages.loaderani.create({width:16,height:16,top:(position.Top + position.Height / 2 - 8),left:(position.Left + position.Width / 2 - 8),zIndex:11001});
			}
			dojo.body().appendChild(suspendAnimation);
		}
	});
	dojo.subscribe("interactionRestrictor/permit", function(layerId) {
		if($(layerId)) {
			dojo.removeClass(dojo.body(), "SuspendUserInteraction");
			epages.loaderani.destroy($(layerId).loaderani);
			dojo.body().removeChild($(layerId));
		}
	});
};

new epages.event.interactionRestrictor;