/* 
 * @charset			utf-8		(ÄÖÜ äöü ß)
 *
 * Copyright (c) 2006-2010, epages GmbH
 * All Rights Reservedojo.
 * epages.fx._base $Revision: 1.1.2.2 $
 */
 	  
	dojo.provide('epages.fx');
	dojo.require('dojo.fx');
	dojo.require('dojo.fx.easing');
	
	dojo.declare('epages.fx._base',null,{
	// summary: base class for epages effects.
	// description: node needs to be specified
		
		/*
		 * private
		 */
		_action: undefined,
		
		/*
		 * public
		 */	   
		node         : undefined,
		containerNode: undefined,
		animations   : undefined,	
		
		addAnimation: function(animate) {
			this.animations.push(
				dojo.animateProperty(
					dojo.mixin(
						{
							'node' : this.node,
							duration : 2000,
							easing: dojo.fx.easing['linear'],
							properties: {}
						},
						animate
					)
				)
			);
		},
		
		addFadeIn: function(duration) {
			this.animations.push(
				dojo.fadeIn({
					node: this.node,
					duration: duration,
					easing: dojo.fx.easing['linear']
				})
			)
		},
		
		addFadeOut: function(duration,delay) {
			this.animations.push(
				dojo.fadeOut({
					node: this.node,
					delay: delay,
					duration: duration,
					easing: dojo.fx.easing['linear']
				})
			)
		},
		
		play: function() {
			this._action = dojo.fx.combine(this.animations)
			this._action.play();
		},
		
		pause: function() {
			this._action.pause();
		},
		
		stop: function() {
			this._action.stop();
		},
		
		/*
		 * init instance
		 */	
		constructor: function(/*DomNode*/ node ) {					   
			this.node = node;
			this.containerNode = node.parentNode;
			
			this.animations = [];
			this._action = dojo.fx.combine(this.animations);
		}
		
	});