/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.html.element $Revision: 1.8.4.1 $

*/
dojo.provide('epages.html.form');
dojo.require('epages.html.element');
dojo.require('epages.lang.hash');

epages.html.Form = function (object) {
	if (object === undefined) {
		console.warn('epages.html.Form: initialize without object.');
		// raise error for callback
		var name = object.className;
	}
	this.object = object;
};

dojo.extend(epages.html.Form, {
	object: undefined,

	get: function () {
		var content = $H();
		for(var i = 0; i < this.object.elements.length; i++){
			var elm = this.object.elements[i];
			if (elm.getAttribute('ep_form') != 'false') {
				var name = elm.name;
				var value = content.get(name);
				if (value === undefined) value = [];
				value.push($E(elm).get());
				content.set(name, value);
			}
		}
		return content;
	},

	set: function (content,callOnChange) {
		if(callOnChange === undefined) callOnChange = true;
		if (dojo.isString(content))
			content = $H(dojo.fromJson(content));

		for(var i = 0; i < this.object.elements.length; i++){
			var elm = this.object.elements[i];
			var name = elm.name;
			var value = content.get(name);
			if(value != '' && value != undefined && elm.getAttribute('widgetid') && (dojo.hasClass(elm,'Radio') || dojo.hasClass(elm,'Checkbox'))){
				$$(elm.getAttribute('widgetid')).setChecked(true);
			}
			if (value !== undefined) {
				var hlm = $E(elm);
				hlm.set(value.shift());
				if(callOnChange) hlm.callOnChange();
				content.set(name, value);
			}
		}
	},

	toString: function() {
		return this.get().toString();
	}

});
