/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.io.Html $Revision: 1.4.52.2 $

*/
dojo.provide('epages.io.html');


epages.io.Html = function (/*String*/url, /*DomObject*/ targetObject) {
	// summary:
	//		Loads html data from url and set the received html data to the target object.
	// example:
	// 	  epages.io.Html('http://www.mydomain.de/header.html', $(header));
	if (url === undefined) return;
	this.load(url, targetObject);
}

dojo.extend(epages.io.Html, {
	load: function (/*String*/url, /*DomObject*/ targetObject, /*Boolean*/syncRequest) {
		// summary:
		//		Loads html data from url and set the received html data to the target object.
		// example:
		// 	  htmlLoader = new epages.io.Html();
		//		htmlLoader.load('http://www.mydomain.de/header.html', $(header));
		if (syncRequest == undefined) syncRequest = false;
	  dojo.xhrGet({
	    url:  url,
	    sync: syncRequest,
	    load: function(data){
	      targetObject.innerHTML = data;
	    },
	    mimetype: "text/plain"
	  });
	}
});
