/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.io.Json $Revision: 1.2.52.1 $

*/
dojo.provide('epages.io.json_test');
dojo.require('epages.io.json');

dojo.extend(epages.io.Json, {
	test: /*Boolean*/ function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var hash = new epages.lang.Hash();
		//		boolean = hash.test(eTest);
		//		// returns true if all test are successfully
		eTest.setPlanned(8);
		// async test
		var waiter = 0;
		var callb = function (data) {
			waiter = 1;
			eTest.ok(data !== undefined, 'async loaded');
			eTest.ok(data.data.LoginRequired == 0, 'async LoginRequired');
		}
		var notcallb = function () {
			if (! waiter) {
				waiter = 1;
				eTest.ok(0, 'async not loaded');
				eTest.ok(0, 'async not found epages tag');
			}
		}
		this.loadAsync('jsonTest.json', callb);
		//  sync test
		var JsonDoc = this.loadSync('jsonTest.json');
		if (JsonDoc !== undefined) {
			eTest.ok(1, 'sync loaded');
			eTest.ok(JsonDoc.data.EbayApiNamespace == 'urn:ebay:apis:eBLBaseComponents', 'sync EbayApiNamespace');
			$('testTarget').innerHTML += JsonDoc.data.Description;
		} else {
			eTest.ok(0, 'sync loaded');
			eTest.ok(0, 'sync found epages tag');
		}

		// error test
		var JsonDoc = this.loadSync('doesnotexist.json');
		if (JsonDoc !== undefined) {
			eTest.ok(1, 'erroneous sync loaded');
			eTest.ok(JsonDoc.error != null, 'erroneous sync, error found');
		} else {
			eTest.ok(0, 'erroneous sync loaded');
			eTest.ok(0, 'erroneous sync, error found');
		}

		// error test
		var callb2 = function (data) {
			waiter = 1;
			eTest.ok(1, 'erroneous sync loaded');
			eTest.ok(data.error != null, 'erroneous aSync, error found');
		}
		var JsonDoc = this.loadAsync('doesnotexist.json', callb2, null, callb2);

		// closing async test
		return eTest.planned == eTest.correct;
	}
});
