/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.io.translation_test $Revision: 1.4.52.1 $

*/
dojo.provide('epages.io.translation_test');
dojo.require('epages.io.translation');

dojo.extend(epages.io.Translation, {
	test: function(/*epages.Test*/ eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var hash = new epages.lang.Hash();
		//		boolean = hash.test(eTest);
		//		// returns true if all test are successfully

		eTest.setPlanned(4);
		this.useLocale = true;
		this.loadLocale('../translation');
		eTest.ok(this.get('Error') == 'Fehler', 'use load');
		eTest.ok(this.replaceLanguageTags('<div>{Notification}</div>') == '<div>Hinweis</div>', 'test method: replaceLanguageTags');

		var translator = new epages.io.Translation('../translation.de.xml');
		eTest.ok(translator.get('Error') == 'Fehler', 'use constructor');

		eTest.ok(epages.io.dictionary.get('Save') == 'Speichern','save global dictionary');

		return eTest.planned == eTest.correct ? true : false; // Boolean
	}

});
