/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.io.xml $Revision: 1.2.52.1 $

*/
dojo.provide('epages.io.xml_test');
dojo.require('epages.io.xml');
dojo.require('epages.lang.uri');

dojo.extend(epages.io.Xml, {

	test: /*Boolean*/ function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	|	var hash = new epages.lang.Hash();
		//	|	boolean = hash.test(eTest);
		//	|	// returns true if all test are successfully
		eTest.setPlanned(5);
		// async test
		var waiter = 0;
		var callb = function (data) {
			waiter = 1;
			eTest.ok(data !== undefined, 'async loaded');
			eTest.ok(data.getElementsByTagName('epages').length == 1, 'async found epages tag');
		}
		var notcallb = function () {
			if (! waiter) {
				waiter = 1;
				eTest.ok(0, 'async not loaded');
				eTest.ok(0, 'async not found epages tag');
			}
		}
		var deferred = this.loadAsync('xmlTest.xml', callb);
		//  sync test
		var xmlDoc = this.loadSync('xmlTest.xml');
		if (xmlDoc !== undefined) {
			eTest.ok(1, 'sync loaded');
			eTest.ok(xmlDoc.getElementsByTagName('epages').length == 1, 'sync found epages tag');
		} else {
			eTest.ok(0, 'sync loaded');
			eTest.ok(0, 'sync found epages tag');
		}

		// test toQueryString();
		var r = epages.lang.uri.toQueryString( { test: 123, test2: 'abc' } );
		eTest.ok(r == 'test=123&test2=abc', 'toQueryString(hash) => ' + r);
		var r = epages.lang.uri.toQueryString( [ ['test', '123'], ['test2', 'abc'] ] );
		eTest.ok(r == 'test=123&test2=abc', 'toQueryString(array[int[2]]) => ' + r);
		var r = epages.lang.uri.toQueryString( [ ['test', '123'], ['test2', 'abc'], ['test', 'same key'] ] );
		eTest.ok(r == 'test=123&test2=abc&test=same%20key', 'toQueryString(array[int[2]]), with duplicate key => ' + r);

		// closing async test
		return eTest.planned == eTest.correct ? true : false;
	}
});
