/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.lang.clipboard $Revision: 1.1.52.1 $

*/
dojo.provide('epages.lang.clipboard_test');
dojo.require('epages.lang.clipboard');

dojo.extend(epages.lang.Clipboard, {

	test: function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var clipboard = new epages.lang.Clipboard();
		//		boolean = clipboard.test(eTest);
		//		// returns true if all test are successfully
		eTest.setPlanned(8);

		var clipboard = this;

		var addValue = 'Value1';
		var addIndex = clipboard.add(addValue);
		eTest.ok(1, 'add returned, index is ' + addIndex);

		var getValue = clipboard.get(addIndex);
		eTest.ok(1, 'get returned');
		eTest.ok(getValue == addValue, 'correct value');

		var setValue = 'Value2';
		eTest.ok(clipboard.set(addIndex, setValue), 'set value');

		var getValue = clipboard.get(addIndex);
		eTest.ok(1, 'get returned');
		eTest.ok(getValue == setValue, 'correct value');

		eTest.ok(!clipboard.set(addIndex + 123, setValue), 'set value at unknown index position');

		var getValue = clipboard.get(addIndex + 123);
		eTest.ok(getValue === undefined, 'get returns undefined for unknown index position');

		return eTest.planned == eTest.correct ? true : false;
	}

});
