/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.lang.date $Revision: 1.3.52.1 $

*/
dojo.provide('epages.lang.date_test');
dojo.require('epages.lang.date');
dojo.require('epages.lang.array');

dojo.mixin(epages.lang.date, {
	test: function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var date = new epages.lang.date();
		//		boolean = date.test(eTest);
		//		// returns true if all test are successfully
		eTest.setPlanned(66);

		// Sunday, Monday, Tuesday, Wednesday, Thursday, , Saturday

		var test1 = true;
		var test4 = true;
		var test7 = true;
		var testSun = true;
		var testMon = true;
		var dates = $A([]); //new Date(2008, 0, 6)
		var date;

		date = new Date(2007, 0, 1); // Monday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  1, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  1, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  1, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) ==  1, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) == 53, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) ==  1, 'mon 7th: ' + date);
		}

		date = new Date(2007, 0, 6); // Saturday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  1, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  1, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  1, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) ==  1, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) == 53, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) ==  1, 'mon 7th: ' + date);
		}
		date = new Date(2007, 0, 7); // Sunday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  2, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  1, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  2, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) ==  1, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) ==  1, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) ==  1, 'mon 7th: ' + date);
		}
		date = new Date(2007, 0, 8); // Monday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {

			date = new Date(2007, 0, 8); // Monday
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  2, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  2, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  2, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) ==  2, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) ==  1, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) ==  2, 'mon 7th: ' + date);

		}
		date = new Date(2008, 0, 1); // Tuesday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  1, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  1, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  1, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) ==  1, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) == 52, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) == 53, 'mon 7th: ' + date);

		}
		date = new Date(2008, 0, 5); // Saturday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  1, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  1, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  1, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) ==  1, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) == 52, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) == 53, 'mon 7th: ' + date);

		}
		date = new Date(2008, 0, 6); // Sunday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  2, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  1, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  2, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) ==  1, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) ==  1, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) == 53, 'mon 7th: ' + date);
		}

		date = new Date(2008, 11, 28); // Sunday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  1, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) == 52, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) == 53, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) == 52, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) == 52, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) == 51, 'mon 7th: ' + date);
		}

		date = new Date(2009, 0, 6); // Tuesday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  2, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  2, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  1, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) ==  2, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) ==  1, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) ==  1, 'mon 7th: ' + date);
		}

		date = new Date(2010, 0, 6); // Wednesday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  2, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  2, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  1, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) ==  1, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) ==  1, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) ==  1, 'mon 7th: ' + date);
		}
		date = new Date(2006, 0, 1); // Sunday
		if(dates.length == 0 || dates.grep(function (el) { return (el.toString() == date.toString())}).length > 0) {
			test1 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,1) ==  1, 'sun on1: ' + date);
			test1 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,1) ==  1, 'mon on1: ' + date);
			test4 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,4) ==  1, 'sun 4th: ' + date);
			test4 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,4) == 52, 'mon 4th: ' + date);
			test7 && testSun && eTest.ok(epages.lang.date.getWeekOfYear(date,0,7) ==  1, 'sun 7th: ' + date);
			test7 && testMon && eTest.ok(epages.lang.date.getWeekOfYear(date,1,7) == 52, 'mon 7th: ' + date);
		}

		return eTest.planned == eTest.correct ? true : false;
	}
});
