/*
	Copyright (c) 2006-2010, epages Software GmbH
	All Rights Reserved.

  epages.loaderani $Revision: 1.4.2.2 $

*/
dojo.provide("epages.loaderani");

epages.loaderani = {

	// summary: shows a loading animation
	// example:
	// | //	to create an animation:
  // | window.aniNode = epages.loaderani.create({width:16, height:16, left:0, top:0, zIndex:1});
  // | //	or
  // | window.aniNode = epages.loaderani.create();
  // | // to remove that animation:
  // | epages.loaderani.destroy(window.aniNode);

	defaultWidth: 50,
	defaultHeight: 50,
	defaultLeft: -9999,
	defaultTop: -9999,
	defaultZIndex: 1
}


epages.loaderani.create = function(/* object */ dimensions, /* dom Node ?*/ domNode) {
// summary: moves the loader animation to the right position
// description:
// animation has to be inside the DOM with id LoaderAniNode already
// dimensions
// | width - integer
// | height - integer
// | top - integer
// | left - integer
// | zIndex - integer
	dimensions = dimensions || {};
	dimensions.width = dimensions.width || this.defaultWidth;
	dimensions.height = dimensions.height || this.defaultHeight;
	dimensions.left = dimensions.left || this.defaultLeft;
	dimensions.top = dimensions.top || this.defaultTop;
	dimensions.zIndex = dimensions.zIndex || this.defaultZIndex;
	var LoaderAniNode = $('LoaderAniNode'); //find existing animation
	if(LoaderAniNode) {
		LoaderAniNode.style.left = dimensions.left + "px";
		LoaderAniNode.style.top = dimensions.top + "px";
		LoaderAniNode.style.zIndex = dimensions.zIndex;
		if(LoaderAniNode.getElementsByTagName("object") && LoaderAniNode.getElementsByTagName("object")[0]) {
			LoaderAniNode.getElementsByTagName("object")[0].width = dimensions.width;
			LoaderAniNode.getElementsByTagName("object")[0].height = dimensions.height;
		}
	}
	return LoaderAniNode;
};

epages.loaderani.destroy = function(aniNode) {
// summary: moves the loader animation out of the visible area
		var LoaderAniNode = $('LoaderAniNode');
		if(LoaderAniNode){
			LoaderAniNode.style.left = "-9999px";
			LoaderAniNode.style.top = "-9999px";
		}
};
