/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.html.element $Revision: 1.7.4.2 $

*/
dojo.provide('epages.localize_test');
dojo.require('epages.localize');
dojo.require('epages.lang.hash');

epages.localize.test = /*Boolean*/ function(/*epages.Test*/eTest) {
	// summary:
	//		test this package
	// example:
	//	|	boolean = epages.localize.test(eTest);
	//	|	// returns true if all test are successfully

	// 20.11.2007 07:54:39
	var testDate = new Date(1195541679123);

  // test cases taken from "{EPAGES}/Cartridges/DE_EPAGES/Dojo/Documents/epages.date - example.txt"
  var pattern = {
    '%a': 'Di',
    '%A': 'Dienstag',
    '%b': 'Nov',
    '%B': 'November',
    '%c': '20.11.2007 07:54:39',
    '%C': '20',
    '%d': '20',
    '%D': '11/20/07',
    '%e': '20',
    '%F': '2007-11-20',
    '%G': '2007',
    '%g': '07',
    '%h': 'Nov',
    '%H': '07',
    '%I': '07',
    '%j': '324',
    '%k': '7',
    '%l': '7',
    '%m': '11',
    '%M': '54',
    '%N': '123000000',
    '%3N': '123',
    '%6N': '123000',
    '%9N': '123000000',
    '%p': 'vorm.',
    '%P': 'vorm.',
    '%r': '07:54:39 vorm.',
    '%R': '07:54',
    '%s': '1195541679',
    '%S': '39',
    '%T': '07:54:39',
    '%u': '2',
    '%U': '46',
    '%V': '47',
    '%w': '2',
    '%W': '46',
    '%x': '20.11.2007',
    '%X': '07:54:39',
    '%y': '07',
    '%Y': '2007',
    '%z': '+0100',
    '%Z': 'CET',
    '%%': '%',
    '%{ce_year}': '2007',
    '%{christian_era}': '%{christian_era}',
    '%{datetime}': '2007-11-20T07:54:39',
    '%{iso8601}': '2007-11-20T07:54:39',
    '%{day_abbr}': 'Di',
    '%{day_name}': 'Dienstag',
    '%{day_of_month}': '20',
    '%{day}': '20',
    '%{mday}': '20',
    '%{day_of_quarter}': '51',
    '%{doq}': '51',
    '%{day_of_week}': '2',
    '%{wday}': '2',
    '%{dow}': '2',
    '%{day_of_year}': '324',
    '%{doy}': '324',
    '%{epoch}': '1195541679',
    '%{era_abbr}': '%{era_abbr}',
    '%{era_name}': '%{era_name}',
    '%{formatter}': '%{formatter}',
    '%{fractional_second}': '39.123',
    '%{hires_epoch}': '1195541679.123',
    '%{hour_1}': '8',
    '%{hour_12_0}': '7',
    '%{hour_12}': '7',
    '%{hour}': '7',
    '%{is_dst}': '0',
    '%{is_finite}': '1',
    '%{is_infinite}': '0',
    '%{is_leap_year}': '0',
    '%{jd}': '2454424.78795282',
    '%{mjd}': '54424.287952818',
    '%{leap_seconds}': '23',
    '%{local_rd_values}': '%{local_rd_values}',
    '%{locale}': 'DateTime::Locale::de=HASH(0x1b03178)',
    '%{microsecond}': '123000',
    '%{millisecond}': '123',
    '%{minute}': '54',
    '%{min}': '54',
    '%{month}': '11',
    '%{mon}': '11',
    '%{month_abbr}': 'Nov',
    '%{month_name}': 'November',
    '%{nanosecond}': '123000000',
    '%{offset}': '3600',
    '%{quarter_abbr}': '%{quarter_abbr}',
    '%{quarter_name}': '%{quarter_name}',
    '%{quarter}': '4',
    '%{second}': '39',
    '%{sec}': '39',
    '%{secular_era}': '%{secular_era}',
    //'%{time_zone_long_name}': 'Europe/Berlin',
    // this value is overridden
    '%{time_zone_long_name}': '+0100',
    '%{time_zone_short_name}': 'CET',
    '%{time_zone}': 'DateTime::TimeZone::Europe::Berlin=HASH(0x182bb98)',
    '%{utc_rd_as_seconds}': '63331224879',
    '%{utc_rd_values}': '123000000',
    '%{week_number}': '47',
    '%{week_of_month}': '4',
    '%{week_year}': '2007',
    '%{week}': '47',
    '%{weekday_of_month}': '3',
    '%{year_with_christian_era}': '%{year_with_christian_era}',
    '%{year_with_era}': '2007CE',
    '%{year_with_secular_era}': '%{year_with_secular_era}',
    '%{year}': '2007'
  };

  var element = $H(epages.localize._patternMap).keys();

	eTest.setPlanned(15 + element.length);
	eTest.ok(1, 'loaded');

  for (var i = 0; i < element.length; i++) {
    try {
      var ok = this.formatDateTime(testDate, element[i]) == pattern[element[i]];
      eTest.ok(ok, element[i] + " replaced correctly");
      if (!ok) console.warn('error:', element[i], "got: '" + this.formatDateTime(testDate, element[i]) + "', expected: '" + pattern[element[i]] + "'");
    } catch(ex) {
      eTest.ok(false, element[i] + " replaced correctly");
    }
  }

	// format number
  eTest.ok(epages.localize.formatNumber(Math.PI, 0) == '3', 'formatNumber(Math.PI, 0)');
  eTest.ok(epages.localize.formatNumber(Math.PI, 1) == '3,1', 'formatNumber(Math.PI, 1)');
  eTest.ok(epages.localize.formatNumber(Math.PI, 2) == '3,14', 'formatNumber(Math.PI, 2)');
  eTest.ok(epages.localize.formatNumber(Math.PI, 4) == '3,1416', 'formatNumber(Math.PI, 4)' + epages.localize.formatNumber(Math.PI, 4));
  eTest.ok(epages.localize.formatNumber(Math.PI, 5) == '3,14159', 'formatNumber(Math.PI, 5)');
  eTest.ok(epages.localize.formatNumber(1.96, 1) == '2', 'formatNumber(1.96, 1)');
  eTest.ok(epages.localize.formatNumber(-1.96) == '-1,96', 'formatNumber(-1.96)');

	// format bytes
  eTest.ok(epages.localize.formatBytes(123, 1) == '123 Byte', 'formatBytes(123, 1)');
  eTest.ok(epages.localize.formatBytes(1234, 1) == '1,2 kB', 'formatBytes(1234, 1)');
  eTest.ok(epages.localize.formatBytes(1279, 1) == '1,2 kB', 'formatBytes(1279, 1)');
  eTest.ok(epages.localize.formatBytes(1280, 1) == '1,3 kB', 'formatBytes(1280, 1)');
  eTest.ok(epages.localize.formatBytes(123456789, 1) == '117,7 MB', 'formatBytes(123456789, 1)');
  eTest.ok(epages.localize.formatBytes(1234567890, 1) == '1,1 GB', 'formatBytes(1234567890, 1)');
  eTest.ok(epages.localize.formatBytes(14453, 1) == '14,1 kB', 'formatBytes(14453, 1)');

	return eTest.planned == eTest.correct ? true : false;
};