/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

  epages.string_test $Revision: 1.3.4.1 $

*/
dojo.provide('epages.string_test');
dojo.require('epages.string');

dojo.mixin(epages.string, {

	test: /*Boolean*/ function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var hash = new epages.lang.Hash();
		//		boolean = hash.test(eTest);
		//		// returns true if all test are successfully
		eTest.setPlanned(6);

		var base64 = new epages.string.Base64;

		var string = 'test';
		var enc = base64.encode(string);
		var dec = base64.decode(enc);
		eTest.ok(enc == 'dGVzdA==', string);
		eTest.ok(dec == string, string);

		string = '<script src="test.js"></script>';
		enc = base64.encode(string);
		dec = base64.decode(enc);
		eTest.ok(enc == 'PHNjcmlwdCBzcmM9InRlc3QuanMiPjwvc2NyaXB0Pg==', epages.string.escapeXml(string));
		eTest.ok(dec == string, epages.string.escapeXml(string));

		string = '10px';
		num = this.cssSizeToNumber(string);
		eTest.ok(num == 10, "cssSizeToNumber: "+string+" : "+num);

		string = '10.11mm';
		num = this.cssSizeToNumber(string);
		eTest.ok(num == 10.11, "cssSizeToNumber: "+string+" : "+num);
	}
});
