dojo.provide("epages.widget.Datetimeinput");
dojo.require("epages.widget");
dojo.require("epages.localize");
dojo.require("dojo.date.locale");
dojo.require("epages.io.translation");
dojo.require("epages.event");
dojo.require('epages.browser');
dojo.require('epages.widget.FormElement');

dojo.declare(
	"epages.widget.Datetimeinput",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl('epages.widget', 'templates/Datetimeinput.html'),
		dojoPattern:        '',
		pattern:            '',
		popupclass:         '',
		'style':            '',
		name:               '',
		textId:             '', // String - id for text node
		value:              '',
		selector:           'date',// String - can be: "date", "time" or "datetime"
		calendar:           null, // dojo._Widjet - insert other calender as parameter
		timer:              null, // dojo._Widjet - insert other time selector as parameter
		hideOnBlur:         true, // Boolean - hide calendar/time on cick outside
		imagePath:          epages.themeUrl('images'),
		image:              '',
		title:              '',
		onchange:           'void(0)',
		firstAvailableDate: '',
		lastAvailableDate:  '',
		disabled:           '',
		textBoxWidget:      undefined, // epages.widget.FormElement -
		textBoxNode:        undefined, // DomNode - dom node of textBoxWidget

		_isChangeInput: 		false, // Boolean - dont not change input field if user makes on input
		// assign selectors to formats
		_formats: {
			'date':     			'dateFormat',
			'time':     			'timeFormat',
			'datetime': 			'datetimeFormat',
			'iso':						'iso'
		},
		_titles: {
			'date':     			'SelectDate',
			'time':     			'SelectTime',
			'datetime': 			'SelectDatetime'
		},
		_formatError: false,
		_ep_connects: undefined, // [] - saved connections


		/* widget life cycle */

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);

			this._ep_connects =[];

			if(this._formats[this.selector] == 'iso'){
				this.value = epages.localize.parseDateTime(this.value, '%y-%m-%d');
				this.pattern = this.pattern || epages.vars.Locale[this._formats['dateFormat']];
			}
			else{
				this.pattern = this.pattern || epages.vars.Locale[this._formats[this.selector]];
			}

			var parsedValue = null;
			if (typeof(this.value) == "string" && this.value != ''){
				parsedValue = epages.localize.parseDateTime(this.value, this.pattern);
			}
			else{
				this.value = null;
			}
			if(parsedValue != null){
				this.value = parsedValue;
			}
			else{
				this._formatError = true;
			}
			//if (typeof(this.value) == "string") this.value = this.value == '' ? null : epages.localize.parseDateTime(this.value, this.pattern);
			var fileType = (epages.Browser.engine == "MSIE" && epages.Browser.version=="6" ) ? "gif" : "png";
			if (this.image == '') this.image = this.imagePath + (this.selector == 'time' ? '/ico_s_clock.'+fileType : '/ico_s_calendar.'+fileType);
			if (this.title == '') this.title = epages.io.dictionary.get(this._titles[this.selector]);
			if (this.firstAvailableDate) this.firstAvailableDate = epages.localize.parseDateTime(this.firstAvailableDate, this.pattern);
			if (this.lastAvailableDate) this.lastAvailableDate = epages.localize.parseDateTime(this.lastAvailableDate, this.pattern);

			this.disabled = this.disabled.toLowerCase();
			this.disabled = (this.disabled =="true" || this.disabled =="disabled" || this.disabled == "1") ? true : false;

		},

		postCreate: function() {
			this.inherited("postCreate", arguments);

			// parse date value and provide to text box and calendar

			this.textBoxWidget = new epages.widget.FormElement({}, this.textBoxNode);
			this.textBoxNode = this.textBoxWidget.elementNode;
			if(this.disabled) {
				this.disable();
			}

			if(!this._formatError) {
				if (this.value  != null) this.setValueInBox(this.value, true);
			}
			else{
				if(this.value) {
					this.textBoxNode.value = this.value;
					// turn red if not empty and formaterror
					dojo.addClass(this.textBoxNode, 'DialogError');
				}
			}
			if (this.textId != '') this.textBoxNode.id = this.textId;
			this._ep_connects.push(dojo.connect(this.buttonNode,  "click",  this, 'toggleCalendar'));
			this._ep_connects.push(dojo.connect(this.textBoxNode, "keyup",  this, "onValueInput"));
			this._ep_connects.push(dojo.connect(this.textBoxNode, "change", this, "onValueInput"));
			this.textBoxNode.onchange = dojo.hitch(this, function() {eval(this.onchange)});
		},

		destroy : function() {
			// detach events
			var connects = this._ep_connects;
			for(var c in connects) {
				dojo.disconnect(connects[c]);
				delete this._ep_connects[c];
			}

			// destroy inner widgets
			if(this.timer) {
				this.timer.destroy();
			}
			if(this.calendar) {
				this.calendar.destroy();
			}
			if(this.popup) {
				this.popup.destroy();
			}
			if(this.textBoxWidget) {
				this.textBoxWidget.destroy();
			}
			this.inherited("destroy", arguments);
		},

		/* public: setter / getter */

		setValueInBox: function(date, startupUpdate) {
			if (date) {
				this.value = new Date(date);
				if (!this._isChangeInput) {
					this.textBoxNode.value = epages.localize.formatDateTime(date, this.pattern);
					if(startupUpdate) {
						this.textBoxNode.startupValue = this.textBoxNode.value;
					}
					dojo.removeClass(this.textBoxNode, 'DialogError');
				}
			} else {
				this.value = undefined;
				this.textBoxNode.value = '';
			}
			dojo.publish(this.id + '/change', [this.value, this.textBoxNode.value]);
			// inform search/submit button
			if(!this._isChangeInput) epages.event.fire(this.textBoxNode,'change');
		},

		setValue: function(date) {
			if(date === undefined || date === null || date == ''){
				this.setValueInBox(undefined);
			}else{
				this.value = typeof(date) == 'string' ? epages.localize.parseDateTime(date, this.pattern) :  new Date(date);
				this.onTimeChange(this.value);
			}
		},

		disable: function() {
		// summary: disable inputfield and button
			this.textBoxNode.disabled="disabled";
			dojo.addClass(this.buttonNode , "Opacity30");
			this.disabled = true;
		},

		enable: function() {
		// summary: enable inputfield and button
			this.textBoxNode.disabled="";
			dojo.removeClass(this.buttonNode , "Opacity30");
			this.disabled = false;
		},

		/* private */

		_createCalendar: function() {
			// summary: create calendar widget
			if( this.value == null ){
				this.value = this.firstStartDate ? this.firstStartDate : new Date();
				if(this.calendar && this.calendar.value && dojo.date.compare(this.calendar.value, this.value, "date")){
					this.value = this.calendar.value;
				};
			}
			if(this.selector != 'date') {
				if (this.timer == null) {
					dojo.require("epages.widget.Timespinner");
					this.timer = new epages.widget.Timespinner({ value: this.value }, this.timerNode);
					if(this.selector != "datetime") {
						this.timer.domNode.style.border = "0";
					}
				} else {
					this.timer.setValue(this.value);
					this.timerNode.parentNode.replaceChild(this.timer.domNode, this.timerNode);
				}
				dojo.subscribe(this.timer.id + '/onChange', this, 'onTimeChange');
			}
			if(this.selector != 'time') {
				if (this.calendar == null) {
					dojo.require("epages.widget.Calendar");
					this.calendar = new epages.widget.Calendar({
						value: this.value,
						timer: this.timer,
						firstAvailableDate: this.firstAvailableDate,
						lastAvailableDate: this.lastAvailableDate
					}, this.calendarNode);
				} else {
					if (this.calendar.setValue === undefined && typeof this.calendar == 'function') {
						this.calendar = this.calendar();
					}
					this.calendar.attr('value',this.value);
					this.calendarNode.parentNode.replaceChild(this.calendar.domNode, this.calendarNode);
				}
				this.calendar.onValueSelected = dojo.hitch(this, 'onCalendarChange');
			}
			this.popup = new epages.widget.Popup({
				parent:     this.buttonNode,
				around:     this.buttonNode,
				hideOnBlur: this.hideOnBlur,
				'class':    this['popupclass']
			}, this.popupNode);
			this.attr('value',this.value);
		},

		/* event functions */

		toggleCalendar: function() {
			if(!this.disabled) {
				if (this.popup == null) this._createCalendar();
				if (this.value === undefined) {
					// set calendar to current date, but dont change input field
					this._isChangeInput = true;
					var newDate = this.firstStartDate ? this.firstStartDate : new Date();
					this.calendar.attr('value',newDate);
					this._isChangeInput = false;
				}
				this.popup.toggle();
			}
		},

		onCalendarChange: function(date) {
			if(this.value === undefined){
				var newDate = this.firstStartDate ? this.firstStartDate : new Date();
				this.value = newDate;
			}
			date.setHours(this.value.getHours(),this.value.getMinutes(),this.value.getSeconds());
			if (this.timer != null){
				this.timer.attr('value',date);
				this.setValueInBox(this.timer.getValue());
			}
			else{
				this.setValueInBox(date);
			}
			if (this.selector == 'date') this.popup.hide();
		},

		onTimeChange: function(date) {
			//var date = new Date(this.value.getFullYear(), this.value.getMonth(), this.value.getDate(), date.getHours(),date.getMinutes(),date.getSeconds());
			if (this.calendar != null) {
				this.value = new Date(date); // set time for onCalendarChange
				if (typeof this.calendar.setValue == 'function') { // calendar loaded
					this.onCalendarChange(date);
					//this.calendar.attr('value',date); // calls onCalendarChange
				} else {
						this.setValueInBox(date);
				}
			} else {
				this.setValueInBox(date);
			}
		},

		onValueInput: function(evt) {
			this._isChangeInput = true;
			var value = this.textBoxNode.value;
			var date = value =='' ? null : epages.localize.parseDateTime(value, this.pattern);
			if (value =='' ||  date != null ) {
				this.attr('value',date);
				dojo.removeClass(this.textBoxNode, 'DialogError');
			} else {
				dojo.addClass(this.textBoxNode, 'DialogError');
			}
			this._isChangeInput = false;
		},

		closePopup: function() {
			this.popup.hide();
		}
	}
);