/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.widget.FormElement $Revision: 1.12.2.1 $

*/

dojo.provide("epages.widget.FormElement");
dojo.require('epages.browser');
dojo.require('epages.event');
dojo.require("epages.widget.LocalizedWidget");

dojo.declare("epages.widget.FormElement", [dijit._Widget], {

	elementNode: null,

	description: "",

	inputType: "hidden", // String -  select, text, radio, checkbox, file

	_inputName: "",

	_allowCheckStatus: true,

	_allowCheckStatusEvent: null,

	_formDescriptionLayer   : null,

	_groupElements: [],

	_ep_connects: undefined,				// [] - saved connections
	_statusInterval: undefined, 		// interval reference

	/* private: transform input */

	_transformElement: function(cropperClass) {
		var oldIndex = this.domNode.selectedIndex;
		var clonedDomNode = this.domNode.cloneNode(true);
		var newContainerNode = document.createElement("span");
		newContainerNode.className = cropperClass + " EnableActive EnableHover " + (this.domNode.disabled ? "Disabled" : "") + (this.domNode.size ? "Sized" : "");
		newContainerNode.appendChild(clonedDomNode);
		this.domNode.parentNode.replaceChild(newContainerNode, this.domNode);
		this.domNode = newContainerNode;
		this.elementNode = this.domNode.getElementsByTagName("*")[0];
		if(oldIndex) {
			this.elementNode.selectedIndex = oldIndex;
		}
	},

	_beautifyElement: function() {
		if(this.domNode.tagName == "SELECT" && epages.Browser.engine == "MSIE") {
			this.inputType = "select";
			this._transformElement("SelectCropper");
			if(this.elementNode.className.match("FullWidth")) {
				this.domNode.style.width = this.domNode.parentNode.offsetWidth + "px";
			}
		}else if(this.domNode.tagName == "SELECT" && epages.Browser.engine != "MSIE") {
			this.inputType = "select";
			this.elementNode = this.domNode;
		}else if(this.domNode.tagName == "TEXTAREA") {
			this.inputType = "text";
			this.elementNode = this.domNode;
		}else if(this.domNode.type && (this.domNode.type.toLowerCase() == "text" || this.domNode.type.toLowerCase() == "password")) {
			if(this.domNode.className.match("Checkbox") || this.domNode.className.match("Radio")) {
				if(!this.domNode.getAttribute("value") && !this.domNode.defaultValue) {this.domNode.defaultValue = "on"}
				this.inputType = "checkbox";
				this.domNode.readOnly = true;
				this.domNode.setAttribute("readonly", true);
				this.domNode.setAttribute("autocomplete", false);
				if(epages.Browser.engine == "WebKit") {
					this._ep_connects.push(dojo.connect(this.domNode, "mouseup", this, function() {this.domNode.blur()}));
				}
				if(this.domNode.attributes["checked"]) {
					this.domNode.checked = this.domNode.attributes["checked"].nodeValue;
				}
				if(this.domNode.checked == true || this.domNode.checked == "checked") {
					dojo.addClass(this.domNode, "Checked");
				}else {
					this.domNode.checked = false;
				}
				if(this.domNode.form && !this.domNode.form.action.match("#") && !this.domNode.originalValue && (this.domNode.value || this.domNode.defaultValue)) {
					this.domNode.originalValue = this.domNode.value || this.domNode.defaultValue;
					this.domNode.value = "";
					this.domNode.defaultValue = "";

					if(!this.domNode.form.eventSet) {
						this.domNode.form.eventSet = true;
						this.domNode.form.submit = dojo.hitch(this.domNode, function() {
							var evtInput = document.createElement("input");
							evtInput.type = "submit";
							evtInput.className = "HideElement";
							this.form.appendChild(evtInput);
							evtInput.click();
						});
					}

					this._ep_connects.push(
						dojo.connect(this.domNode.form, "submit", this.domNode, function(evt) {
							if((this.checked || this.checked == "checked")) {
								this.value = this.originalValue;
							}else {
								this.name = "";
							}
						})
					);
				}
				if(this.domNode.onclick || this.domNode.onchange) {
					this.domNode._tempOnclick = this.domNode.getAttribute("onclick");
					this.domNode._tempOnchange = this.domNode.getAttribute("onchange");
					this.domNode.removeAttribute("onclick");
					this.domNode.removeAttribute("onchange");
					this.domNode.onclick = function(){void(0)};
					this.domNode.onchange = function(){void(0)};
				}

				this._ep_connects.push(
					dojo.connect(this.domNode, "click", this.domNode, function(evt) {
						if(this.className.match("Radio")) {
							if(!this._groupElements) {
								this._groupElements = dojo.query("input[name=" + this.name + "].Radio");
							}
							var groupElements = this._groupElements;
							for(var i = 0; i < groupElements.length; i++) {
								if((groupElements[i].checked == true || groupElements[i].checked == "checked") && groupElements[i].className.match("Checked")) {
									groupElements[i].checked = false;
									dojo.removeClass(groupElements[i], "Checked");
								}
							}
						}
						if((this.checked == true || this.checked == "checked") && this.className.match("Checked") && !this.className.match("Radio")) {
							this.checked = false;
							dojo.removeClass(this, "Checked");
						}else if(!this.className.match("Checked")){
							this.checked = true;
							dojo.addClass(this, "Checked");
						}
						if(this._tempOnclick) {
							if(epages.Browser.engine == "MSIE") {
								(dojo.hitch(evt.currentTarget, this._tempOnclick))();
							}else {
								eval(this._tempOnclick);
							}
						}
						if(this._tempOnchange) {
							if(epages.Browser.engine == "MSIE") {
								(dojo.hitch(evt.currentTarget, this._tempOnchange))();
							}else {
								eval(this._tempOnchange);
							}
						}
						epages.event.fire(this, "change");
					})
				);
			}else {
				this.inputType = "text";
				if(epages.Browser.engine == "MSIE") { // force IE to update the cursor position after navigation key input
					var updateCursorPosition = function(domNode) {
						domNode.className += "";
					};
					this._ep_connects.push(
						dojo.connect(this.domNode, "keyup", this, function(evt) {
							if(evt.keyCode == dojo.keys.HOME ||
							evt.keyCode == dojo.keys.END ||
							evt.keyCode == dojo.keys.PAGE_DOWN ||
							evt.keyCode == dojo.keys.PAGE_UP ||
							evt.keyCode == dojo.keys.RIGHT_ARROW ||
							evt.keyCode == dojo.keys.LEFT_ARROW) {
								updateCursorPosition(this.domNode);
							}
						})
					);

					this._ep_connects.push(
						dojo.connect(this.domNode, "keydown", this, function(evt) {
							if(evt.keyCode == dojo.keys.RIGHT_ARROW || evt.keyCode == dojo.keys.LEFT_ARROW) {
								updateCursorPosition(this.domNode);
							}
						})
					);

				}
			}
			this.elementNode = this.domNode;
		}else if(this.domNode.type && this.domNode.type.toLowerCase() == "checkbox") {
			this.inputType = "checkbox";
			this.elementNode = this.domNode;
		}else if(this.domNode.type && this.domNode.type.toLowerCase() == "radio") {
			this.inputType = "radio";
			this.elementNode = this.domNode;
		}else if(this.domNode.type && this.domNode.type.toLowerCase() == "file") {
			this.inputType = "file";
			this._transformElement("FileinputCropper");
			this._dictionary = new epages.io.Translation(dojo.moduleUrl('epages.widget', "templates/translation"), "auto");
			this.domNode.innerHTML = "<input onkeyup='$$(dojo.query(\"input[type=file]\", this.parentNode)[0].id).checkFileInputMethod(this)' type='text'/><span class='Button'><span class='ButtonContainer'>" + this._dictionary.get("Browse") + "...</span></span><b>" + this.domNode.innerHTML + "</b>";
			this.elementNode = dojo.query("input[type=file]", this.domNode)[0];
			this._ep_connects.push(
				dojo.connect(this.elementNode, "mouseover", this, function(evt) {
					var fakedButton = dojo.query(".Button", evt.currentTarget.parentNode.parentNode)[0];
					fakedButton.setAttribute("hovered", "");
					dojo.addClass(fakedButton, "hovered");
				})
			);
			this._ep_connects.push(
				dojo.connect(this.elementNode, "mouseout", this, function(evt) {
					var fakedButton = dojo.query(".Button", evt.currentTarget.parentNode.parentNode)[0];
					fakedButton.removeAttribute("hovered", "");
					dojo.removeClass(fakedButton, "hovered");
				})
			);
			this._ep_connects.push(
				dojo.connect(this.elementNode, "change", this, function(evt) {
					var fakedField = dojo.query("input[type=text]", evt.currentTarget.parentNode.parentNode)[0];
					fakedField.value = evt.currentTarget.value;
				})
			);
		}
		this._inputName = this.elementNode.name;
		this._checkStatus();
	},

	_updateCheckbox: function(evt) {
		var childInput = evt.target.getElementsByTagName("input")[0];
		if(childInput) {
			epages.event.fire(childInput, "click");
			if(epages.Browser.engine == "MSIE") {
				childInput.checked = !childInput.checked;
			}
		}
	},

	_checkKeyInput: function(evt) {
		if(this.elementNode && (this.elementNode.className.match("Radio") || this.elementNode.className.match("Checkbox")) && evt && evt.keyCode == 32) {
			epages.event.fire(this.elementNode, "click");
		}
	},

	_checkStatus: function(evt) {
		if(this.elementNode && this.domNode) {
			if(this.elementNode.disabled) {
				dojo.addClass(this.domNode, "Disabled");
				dojo.addClass(this.elementNode, "Disabled");
			}else {
				dojo.removeClass(this.domNode, "Disabled");
				dojo.removeClass(this.elementNode, "Disabled");
			}
			if(this.elementNode.className.match("Radio")) {
				var groupElements = this._groupElements;
				for(var i = 0; i < groupElements.length; i++) {
					if(!(groupElements[i].checked == true || groupElements[i].checked == "checked")) {
						dojo.removeClass(groupElements[i], "Checked");
					}
				}
			}
			if(this.elementNode.checked) {
				dojo.addClass(this.domNode, "Checked");
			}else {
				dojo.removeClass(this.domNode, "Checked");
			}
		}
	},

	checkFileInputMethod: function(domNode) {
		if(domNode.value.length == 0) {
			this.elementNode.style.visibility = "visible";
			this.elementNode.name = this._inputName;
			domNode.name = "";
			dojo.removeClass(dojo.query(".Button", this.domNode)[0], "Disabled");
		}else {
			domNode.name = this._inputName;
			this.elementNode.name = "";
			this.elementNode.style.visibility = "hidden";
			dojo.addClass(dojo.query(".Button", this.domNode)[0], "Disabled");
		}
	},

	_showDescription: function(evt) {
		var formElement = evt.currentTarget;
		if(formElement.getAttribute("description") && formElement.getAttribute("description").length > 1) {
			if(this._formDescriptionLayer) {
				var layer = this._formDescriptionLayer;
				layer.className = layer.className.replace(/HideElement/, "");
				if(layer.offsetWidth > 300) {
					layer.style.width = "300px";
				}
				dojo.fadeIn({node: layer, duration:200}).play();
			}else {
				var elementPosition = $E(this.domNode).getAbsolutePosition();

				this._formDescriptionLayer = document.createElement("div");

				var layerShadow = document.createElement("div");
				layerShadow.className = "TooltipShadow";

				with(this._formDescriptionLayer) {
					innerHTML = unescape(formElement.getAttribute("description")).replace(/&lt;/g, "<").replace(/&gt;/g, ">");
					className = "Tooltip HideElement Wide";
					onselectstart = function(){return false};
					style.MozUserSelect = "none";
					style.WebkitUserSelect = "ignore";
					style.left = (elementPosition.x + this.domNode.offsetWidth + 2) + "px";
					style.top = elementPosition.y + "px";
					style.display = "block";
					appendChild(layerShadow);
				}

				dojo.style(this._formDescriptionLayer, "opacity", 0);

				dojo.body().appendChild(this._formDescriptionLayer);

				this._showDescription(evt);
			}
		}
	},

	_hideDescription: function(evt) {
		if(this._formDescriptionLayer) {
			var layer = this._formDescriptionLayer;
			dojo.fadeOut({node: layer, duration:200}).play();
			setTimeout(function() {layer.className += " HideElement"}, 200);
		}
	},

	_highlightChanges: function() {
		var classStyleNode = this.elementNode
		if(classStyleNode.tagName == "SELECT" && epages.Browser.engine == "MSIE") {
			classStyleNode = this.domNode;
		}

		switch (this.inputType) {
			case "text":
				if(classStyleNode.startupValue != classStyleNode.value) {
					dojo.addClass(classStyleNode, "Changed");
				}else {
					dojo.removeClass(classStyleNode, "Changed");
				}
				if(classStyleNode.className.match("Mandatory") && classStyleNode.value.length < 1) {
					dojo.addClass(classStyleNode, "Unfilled");
				}else {
					dojo.removeClass(classStyleNode, "Unfilled");
				}
				break;
			case "select":
				if(epages.Browser.engine == "MSIE") {classStyleNode = this.domNode}
				if(this.elementNode.startupIndex != this.elementNode.selectedIndex) {
					dojo.addClass(classStyleNode, "Changed");
				}else {
					dojo.removeClass(classStyleNode, "Changed");
				}
				break;
			case "radio":

				break;
			case "checkbox":

				break;
			case "file":
				classStyleNode = this.domNode.firstChild;
				if(classStyleNode.value.length > 1) {
					dojo.addClass(classStyleNode, "Changed");
				}else {
					dojo.removeClass(classStyleNode, "Changed");
				}
				break;
		}

	},

	/* public: getter / setter */

	setChecked: function(checked) {
		if(this.elementNode.className.match("Radio")) {
			if(checked) {
				var groupElements = dojo.query("input[name=" + this.elementNode.name + "].Radio");
				for(var i = 0; i < groupElements.length; i++) {
					groupElements[i].checked = false;
				}
				this.elementNode.checked = true;
				epages.event.fire(this.elementNode, "change");
			}
		}else {
			this.elementNode.checked = checked;
			epages.event.fire(this.elementNode, "change");
		}
		this._checkStatus();
		if(this.domNode._tempOnclick) {
			if(epages.Browser.engine == "MSIE") {
				(dojo.hitch(this.domNode, this.domNode._tempOnclick))();
			}else {
				(dojo.hitch(this.domNode, function(){eval(this._tempOnclick)}))();
			}
		}
		if(this.domNode._tempOnchange) {
			if(epages.Browser.engine == "MSIE") {
				(dojo.hitch(this.domNode, this.domNode._tempOnchange))();
			}else {
				(dojo.hitch(this.domNode, function(){eval(this._tempOnchange)}))();
			}
		}
	},

	isChecked: function() {
	// summary: returns if input is checked
		return this.domNode.checked;
	},

	getValue: function() {
	// summary: returns current value of input
		if(this.inputType == "radio" || this.inputType == "checkbox") {
			return this.elementNode.startupValue || this.elementNode.originalValue;
		} else {
			return this.domNode.value;
		}
	},

	setValue: function(v) {
	// summary: set current value of input
		if(this.inputType == "radio" || this.inputType == "checkbox") {
			this.elementNode.startupValue = v;
		} else {
			this.domNode.value = v;
		}
	},

	setStartUpValue : function(v) {
	// summary: set startup value of input
		this.elementNode.startupValue = v;
		this._checkStatus();
	},

	/**
	 * widget life cycle
	 **/

	postCreate: function() {
		this.inherited("postCreate", arguments);
		this._ep_connects = [];

		this._beautifyElement();
		if(this.elementNode && this.elementNode.tagName != this.domNode.tagName) {
			this.domNode.className += " " + this.elementNode.className;
			this.domNode.setAttribute("style", this.elementNode.getAttribute("style"));
		}
		if(this.elementNode && this.domNode) {
			this._ep_connects.push(dojo.connect(dojo.body(), "mouseup", this, "_checkStatus"));
			this._ep_connects.push(dojo.connect(this.elementNode, "keyup", this, "_checkKeyInput"));
			this._statusInterval = setInterval(dojo.hitch(this, function() {
				this._checkStatus();
				this._highlightChanges();
			}), 400);
			if((this.elementNode.type && this.elementNode.type == "text" && !this.elementNode.className.match("Radio") && !this.elementNode.className.match("Checkbox")) || this.elementNode.tagName == "SELECT" || this.elementNode.tagName == "TEXTAREA") {
				this._ep_connects.push(dojo.connect(this.elementNode, "focus", this, "_showDescription"));
				this._ep_connects.push(dojo.connect(this.elementNode, "blur", this, "_hideDescription"));
			}

			this.elementNode.startupValue = this.elementNode.value;
			this.elementNode.startupIndex = this.elementNode.selectedIndex;
			this.elementNode.startupChecked = this.elementNode.checked;
			this._ep_connects.push(dojo.connect(this.elementNode, "change", this, "_highlightChanges"));
			this._highlightChanges();

			if(this.elementNode.getAttribute("emptyValue")) {
				var elNode = this.elementNode;
				dojo.addClass(elNode, "EmptyValue");
				if(this.elementNode.form) {
					this._ep_connects.push(
						dojo.connect(this.elementNode.form, "submit", function() {
							elNode.value = elNode.value.replace(elNode.getAttribute("emptyValue"), "");
							dojo.removeClass(elNode, "EmptyValue");
						})
					);
				}
				this._ep_connects.push(
					dojo.connect(this.elementNode, "focus", function() {
						elNode.value = elNode.value.replace(elNode.getAttribute("emptyValue"), "");
						dojo.removeClass(elNode, "EmptyValue");
					})
				);
				this._ep_connects.push(
					dojo.connect(this.elementNode, "blur", function() {
						if(elNode.value == "") {
							dojo.addClass(elNode, "EmptyValue");
							elNode.value = elNode.getAttribute("emptyValue");
						}
					})
				);
			}
		}
	},

	destroy : function() {
		// summary: delete interval and detach events
		if(this._statusInterval) {
			clearInterval(this._statusInterval);
		}

		// detach events
		var connects = this._ep_connects;
		for(var c in connects) {
			dojo.disconnect(connects[c]);
			delete this._ep_connects[c];
		}
		this.inherited("destroy", arguments);
	}
});