/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.metacafe');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.Metacafe = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.Metacafe,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.Metacafe',
	title           : 'Metacafe',
	metacafeInput   : '',
	width           : 440,
	height          : 334,
	size            : '',
	embededlink     : 'http://www.metacafe.com/watch/',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_metacafe.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			metacafeInput  : this.metacafeInput,
			videosize      : this.size
		});
		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}
		
		if(this.formData.get('videosize')[0] === "large"){
			this.width = 600;
			this.height = 370;
		}
		else if(this.formData.get('videosize')[0] === "medium"){
			this.width = 540;
			this.height = 334;
		}
		else{
			this.width = 440;
			this.height = 272;
		}
		
		this.size = this.formData.get('videosize')[0];
	},
	_getVideoId:function(input){
		var videoid = '';
		
		var RegExp = /([0-9]+\/\w+)/; //RegExp to find videoid in URL & embed
		videoid = RegExp.exec(input);
		
		if(videoid !== "" && videoid !== null){
			return videoid[1];
		}
		else{
			return false;
		}
	},
	contentString: function (info, ispreview) {
		if(info.formData.get('metacafeInput')){
			info.metacafeInput = info.formData.get('metacafeInput')[0];

			var videoid = this._getVideoId(info.metacafeInput);
			if(videoid === false){
				if(this.messageWidget === undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('metacafeError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
			}
			else{
				
				//document.getElementsByName('metacafeInput').value = videoid; // fr IE
					
				var ausgabe = '<div style="background:transparent;width:'+ this.width +'px;height:'+ this.height +'px">'+
								'<embed flashVars="playerVars=showStats=no|autoPlay=no|" '+ 
								'src="http://www.metacafe.com/fplayer/'+ videoid +'.swf"'+ 
								'width="'+ this.width +'" height="'+ this.height +'"'+ 
								'wmode="transparent" allowFullScreen="true" allowScriptAccess="always" name="Metacafe"'+ 
							  'pluginspage="http://www.macromedia.com/go/getflashplayer" type="application/x-shockwave-flash"></embed></div>';

				return ausgabe;
			}
		}
		else{
			return "&nbsp;";
		}
	},
	mceInsertContent: function(info){
		if (info === undefined){
			info = this.info();
		}	
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});