/*
	Copyright (c) 2010, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide('epages.cartridges.de_epages.externalcontent.socialbookmarks');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.widget.Modaldialog');
dojo.require('epages.io.translation');

epages.cartridges.de_epages.externalcontent.SocialBookmarks = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.SocialBookmarks,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.SocialBookmarks',
	title           : 'Social Bookmarks',

	digg						: 'false',
	delicious				: 'false',
	stumbleupon			: 'false',
	technorati			: 'false',
	mrwong					: 'false',

	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_socialbookmarks.png',
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			digg				: this.digg,
			delicious		: this.delicious,
			stumbleupon : this.stumbleupon,
			technorati  : this.technorati,
			mrwong			: this.mrwong
		});

		return info;
	},
	saveForm: function() {
		if (this.form !== undefined){
			this.formData = (new epages.html.Form(this.form)).get();
		}


		if(this.formData.get('digg') == "on"){
			this.digg = 'true';
		}
		else {
			this.digg = 'false';
		}

		if(this.formData.get('delicious') == "on"){
			this.delicious = 'true';
		}
		else {
			this.delicious = 'false';
		}

		if(this.formData.get('stumbleupon') == "on"){
			this.stumbleupon = 'true';
		}
		else {
			this.stumbleupon = 'false';
		}

		if(this.formData.get('technorati') == "on"){
			this.technorati = 'true';
		}
		else {
			this.technorati = 'false';
		}

		if(this.formData.get('mrwong') == "on"){
			this.mrwong = 'true';
		}
		else {
			this.mrwong = 'false';
		}

	},

	contentString: function (info, ispreview) {
		if (info === undefined){
			var info = this.info();
		}

		if(this.digg == 'true' ||
		   this.delicious  == 'true' ||
		   this.stumbleupon  == 'true' ||
		   this.technorati  == 'true' ||
		   this.mrwong == 'true' ){

				var target = ' target="_blank"';
				var href = epages.vars.CanonicalURL;
				var retString = "<div id='SocialBookmarksButtons'>";
				var spacer = "&nbsp;";

			  if( this.digg == 'true'){
					retString += '<a href="http://digg.com/submit?url=' + href + '"' + target + '><img src="'+ epages.vars.StoreRoot +'/SF/SocialWeb/ico_bookmark_digg.png" alt="digg" title="digg" border="0" /></a>' + spacer;
				}
				if( this.delicious == 'true'){
					retString += '<a href="http://www.delicious.com/save?url=' + href + '"'  + target + '><img src="'+ epages.vars.StoreRoot +'/SF/SocialWeb/ico_bookmark_delicious.png" alt="delicious" title="delicious" border="0" /></a>' + spacer;
				}
				if( this.stumbleupon == 'true'){
					retString += '<a href="http://www.stumbleupon.com/submit?url=' + href + '"'  + target + '><img src="'+ epages.vars.StoreRoot +'/SF/SocialWeb/ico_bookmark_stumbleupon.png" alt="StumbleUpon" title="StumbleUpon" border="0" /></a>' + spacer;
				}
				if( this.technorati == 'true'){
					retString += '<a href="http://technorati.com/faves?add=' + href + '"'  + target + '><img src="'+ epages.vars.StoreRoot +'/SF/SocialWeb/ico_bookmark_technorati.png" alt="Technorati" title="Technorati" border="0" /></a>' + spacer;
				}
				if( this.mrwong == 'true'){
					retString += '<a href="http://www.mister-wong.de/addurl/?bm_url=' + href + '"'  + target + '><img src="'+ epages.vars.StoreRoot +'/SF/SocialWeb/ico_bookmark_mrwong.png" alt="Mister Wong" title="Mister Wong" border="0" /></a>' + spacer;
				}
				retString += "</div>";
				return retString;
		}
		else{
				if(this.messageWidget == undefined) {
					var message = new epages.widget.Message({
								headline:this.translation.get('Error'),
								message:this.translation.get('SocialBookmarkError'),
								sizeClass:"Large",
								typeClass:"Warning"
							});
					this.messageWidget = new epages.widget.Modaldialog({
						options:{
							title : this.translation.get('Error'),
							content : message
						},
						buttons: [{
							label: this.translation.get('OK'),
							cssClass: 'Active',
							onclick: function() {
							this._modalDialogWidget.hide();
							}
						}]
					});
				}
				document.body.appendChild(this.messageWidget.domNode);
				this.messageWidget.show();
				return "&nbsp;";
		}
	},

	mceInsertContent: function(info){
		if (info === undefined){
			var info = this.info();
		}

		info.formData._data['digg'][0] = this.digg == 'true' ? "on" : "";
		info.formData._data['delicious'][0] = this.delicious == 'true' ? "on" : "";
		info.formData._data['stumbleupon'][0] = this.stumbleupon == 'true' ? "on" : "";
		info.formData._data['technorati'][0] = this.technorati == 'true' ? "on" : "";
		info.formData._data['mrwong'][0] = this.mrwong == 'true' ? "on" : "";

		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});