﻿/*
	Copyright (c) 2009, epages Software GmbH
	All Rights Reserved.
*/


dojo.provide('epages.cartridges.de_epages.externalcontent.twittertweetthis');
dojo.require('epages.cartridges.de_epages.design.mcecontent');
dojo.require('epages.widget.Message');
dojo.require('epages.io.text');
dojo.require('epages.io.translation');
dojo.require('epages.html.element');
dojo.require('epages.string');
dojo.require('epages.lang.hash');

epages.cartridges.de_epages.externalcontent.TwitterTweetThis = epages.Class();

dojo.extend(epages.cartridges.de_epages.externalcontent.TwitterTweetThis,
	epages.cartridges.de_epages.design.MceContent.prototype, {
	contentClass    : 'epages.cartridges.de_epages.externalcontent.TwitterTweetThis',
	title           : 'TwitterTweetThis',
	width           : 250,
	height          : 300,

	ButtonCount			: 'vertical',
	TweetText				: '', // var for radio-button, use the title of the current page or use an own text
	TweetText_Insert: '',
	TweetURL				: '', // var for radio-button, use current URL of page or use another url
	TweetURL_Insert : '',
	TwitterAccountName0 : '', // var for radio-button, append a name or not
	Twitter_AccountName : '', // The inserted TwitterName, append on String "@Name"

	embededlink     : 'http://www.twitter.com',
	preview         : epages.vars.StoreRoot + '/BO/icons/navelement_twitter_this.png',
	directPreview   : false,
	messageWidget   : undefined,
	translation     : new epages.io.Translation(dojo.moduleUrl('epages.cartridges.de_epages.externalcontent', "templates/translation"), "auto"),
	b64							: new epages.string.Base64(),

	info: function () {
		var info = epages.cartridges.de_epages.design.MceContent.prototype.info.apply(this, arguments);
		dojo.mixin(info, {
			ButtonCount          : this.ButtonCount,
			width             	 : this.width,
			height             	 : this.height,
			TweetText            : this.TweetText,
			TweetText_Insert     : this.TweetText_Insert,
			TweetURL             : this.TweetURL,
			TweetURL_Insert      : this.TweetURL_Insert,
			TwitterAccountName0  : this.TwitterAccountName0,
			Twitter_AccountName  : this.Twitter_AccountName
		});
		return info;
	},

	contentString: function (info, ispreview) {
		var finalstring = "";

		if(!$E(this.formData._data).isEmpty()){
			var info = this._getFormData(this.formData);
			if(info){
				finalstring = this._getString(info);
			}
		}

		return finalstring;
	},

	loadPreview: function (domObject) {
			if(!$E(this.formData._data).isEmpty()){
				var info = this._getFormData(this.formData);
				var url = 'twittertweetthispreview.html?';

				url += this.b64.encode($H(info).toString());
				domObject.src = dojo.moduleUrl('epages.cartridges.de_epages.externalcontent',url);
			}
	},

	_getFormData: function (sourceobject) {
		var info = {};

		if( sourceobject.get('ButtonCount')[0] != "" ){
			info.ButtonCount = sourceobject.get('ButtonCount')[0];
		} else{
				if( sourceobject.get('ButtonCount')[1] != "" ){
					info.ButtonCount = sourceobject.get('ButtonCount')[1];
			  } else{
						info.ButtonCount = sourceobject.get('ButtonCount')[2];
				}
		}

		if( sourceobject.get('TweetText')[0] != "" ) {
			info.TweetText = sourceobject.get('TweetText')[0];
		} else {
				info.TweetText = sourceobject.get('TweetText')[1];
				info.TweetText_Insert = sourceobject.get('TweetText_Insert');
		}

		if( sourceobject.get('TweetURL')[0] != "" ) {
			info.TweetURL = sourceobject.get('TweetURL')[0];
		} else {
				info.TweetURL = sourceobject.get('TweetURL')[1];
				info.TweetURL_Insert = sourceobject.get('TweetURL_Insert');
		}


		if( sourceobject.get('TwitterAccountName0')[0] == "No Twitter Account Name" ) {
			info.TwitterAccountName0 = sourceobject.get('TwitterAccountName0')[0];
			info.Twitter_AccountName = '';
		} else {
				info.TwitterAccountName0 = sourceobject.get('TwitterAccountName0')[1];
				info.Twitter_AccountName = sourceobject.get('Twitter_AccountName');
		}

		return info;
	},

	_getString: function (info) {
		// summary: Using the given info object, compose the html code string of the gadget.
		// description: Fills the variable parameters into the twitter gadget code. The actual
		//	gadget is fetched from widgets.twimg.com via a script tag. Then a simply object instance
		//		of that gadget is created, supplied with all the setup parameters.

			var paraString = 'data-count='+info.ButtonCount;

      if( info.TweetText == "OwnTweetText"){
      	paraString += ' data-text="'+info.TweetText_Insert+'"';
      }
      if( info.TweetURL == "OwnURL"){
      	paraString += ' data-url="'+info.TweetURL_Insert+'"';
      }
      if( info.Twitter_AccountName != ''){
      	paraString += ' data-via="'+info.Twitter_AccountName+'"';
      }

	  var finalstring =
			' <a href="http://twitter.com/share" class="twitter-share-button" ' + paraString + '>Tweet</a><script type="text/javascript" src="http://platform.twitter.com/widgets.js"</script>';
    return finalstring;
	},

	mceInsertContent: function(info){
		if (info === undefined){
			info = this.info();
		}
		epages.cartridges.de_epages.design.MceContent.prototype.mceInsertContent.apply(this, arguments);
	}
});