IF OBJECT_ID('i_LineItemPaymentDCC') IS NOT NULL
    DROP PROCEDURE i_LineItemPaymentDCC
GO
CREATE PROCEDURE i_LineItemPaymentDCC (
    @LineItemPaymentDCCID int          
,   @CreditCardType       varchar(255) = null
,   @CreditCardOwner      varchar(255) = null
,   @CreditCardNumber     varchar(64)  = null
,   @ValidFromMonth       int          = null
,   @ValidFromYear        int          = null
,   @ValidThruMonth       int          = null
,   @ValidThruYear        int          = null
,   @CVV                  varchar(64)  = null
,   @IssueNumber          varchar(64)  = null
) AS BEGIN
    DECLARE @TransactionCount int
    SELECT @TransactionCount = @@trancount

    IF @TransactionCount > 0 SAVE  TRANSACTION ti_lineitempaymentdcc
    ELSE                     BEGIN TRANSACTION ti_lineitempaymentdcc

        INSERT INTO lineitempaymentdcc
               ( lineitempaymentdccid, creditcardtype, creditcardowner, creditcardnumber, validfrommonth, validfromyear, validthrumonth, validthruyear, cvv, issuenumber)
        SELECT  @LineItemPaymentDCCID,@CreditCardType,@CreditCardOwner,@CreditCardNumber,@ValidFromMonth,@ValidFromYear,@ValidThruMonth,@ValidThruYear,@CVV,@IssueNumber

        IF NOT @@transtate IN (0, 1)
        BEGIN
            ROLLBACK TRANSACTION ti_lineitempaymentdcc
            RETURN 1
        END

    IF @TransactionCount = 0
        COMMIT TRANSACTION ti_lineitempaymentdcc
    RETURN 0
END
GO
