/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.

	epages.browser $Revision: 1.1.62.1 $

*/
dojo.provide('epages.cartridges.de_epages.presentation.objectupdater_test');
dojo.require('epages.cartridges.de_epages.presentation.objectupdater');

dojo.extend(epages.cartridges.de_epages.presentation.ObjectUpdater, {
	test: /*Boolean*/ function(/*epages.Test*/eTest) {
		// summary:
		//    test this package
		// example:
		//   | var hash = new this.package();
		//   | boolean = hash.test(eTest);
		//   | // returns true if all test are successfully
		eTest.setPlanned(4);
		eTest.ok(1,'loaded');
		var sollString =  'GUID=1234-5678-90&Name=Font&Value=Arial&GUID=1234-5678-90&Name=Size&Value=8px';
		var hString = this.getFormDataViaHash('1234-5678-90', {
			Font: 'Arial',
			Size: '8px'
		});
		eTest.ok(hString == sollString, 'getFormDataViaHash()');

		var aString = this.getFormDataViaArray([{
			GUID  : '1234-5678-90',
			Name  : 'Font',
			Value : 'Arial'
		},{
			GUID  : '1234-5678-90',
			Name  : 'Size',
			Value : '8px'
		}]);
		eTest.ok(aString == sollString, 'getFormDataViaArray()');

		var oString = this.getFormDataViaObjectForm({
			'1234-5678-90:Font': 'Arial',
			'1234-5678-90:Size': '8px'
		});
		eTest.ok(oString == sollString, 'getFormDataViaObjectForm()');

		return eTest.planned == eTest.correct ? true : false;
	}
});