/*Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.
	epages.cartridges.de_epages.presentation.widget.Colorpicker $Revision: 1.13.2.1 $*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.Linkcreator");
dojo.require("epages.widget.Modaldialog");
dojo.require("epages.widget.FormElement");
dojo.require("epages.cartridges.de_epages.presentation.widget.Objectstore");
dojo.require("epages.cartridges.de_epages.presentation.widget.Objecttree");
dojo.require('epages.format');
dojo.require('epages.epages_scripts');
dojo.require('epages.io.json');
dojo.require('dijit.Dialog');

dojo.declare("epages.cartridges.de_epages.presentation.widget.Linkcreator",
	[epages.widget.Modaldialog],
	{
		/**
		* public properties
		*/
		label            		: "{EditLink}",
		query            		: '',
		widgetsInTemplate		: true,
		innerTemplatePath		: dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget','templates/Linkcreator.html'),
		innerTemplateString	: '',
		translationName  		: dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget','templates/translation'),
		useAbsolutePath			: false,
		useSSL              : false,
		url                 : '?',
		siteId            : epages.vars.SiteID,
		options: {
			title : "select a page",
			width : 450,
			content: undefined
		},

		buttons: [],

		_storeRoot						: undefined,
		_storeFrontUrl				: undefined,
		_advancedLinks				: undefined,

		// override
		postMixInProperties: function() {
			if(window.objectStore === undefined){
				dojo.require("epages.cartridges.de_epages.presentation.widget.Objectstore");
				window.objectStore = new epages.cartridges.de_epages.presentation.widget.Objectstore({
					jsId:      "objectStore",
					id:        "objectStore"
				});
			}

			if (this.query == '') {
				if(epages.topWindow && epages.topWindow.objectStore && epages.topWindow.objectStore.objectId != null)
					this.query = "{id:" + epages.topWindow.objectStore.objectId + "}";
				else this.query = "{id:" + epages.vars.CategoriesID + "}";
			}
			this.inherited('postMixInProperties', arguments);
			if(epages.vars.StoreRoot)
				this._storeRoot = epages.vars.StoreRoot;
			else
				console.warn('epages.vars.StoreRoot not defined in '+this.declaredClass);

			if(epages.vars.StoreFrontUrl)
				this._storeFrontUrl=epages.vars.StoreFrontUrl;
			else
				console.warn('epages.vars.StoreFrontUrl not defined in '+this.declaredClass);

			this.label = this.translation.replaceLanguageTags(this.label);
		},

		postCreate: function() {
			dijit.Dialog.prototype.postCreate.apply(this, arguments);
			this.buttons = [
				{
					label: this.translate('Apply'),
					cssClass: 'Active',
					onclick: dojo.hitch(this, this.onApplyClick),
					parentLink: undefined,
					tinyMCEInstance: undefined
				},
				{
					label: this.translate('Cancel'),
					onclick: dojo.hitch(this, this.hide)
				}
			];

			//set titles for modaldialog and tree
			this.options.title = this.label;
			//this.options.content = this.domNode;
			//attach event
			this._createContent(this.options);
			this._createButtons(this.buttons);
			dojo.subscribe('LinkcontrollerTree/select', this, function(selectedNode) {
				this.onSelectPage(selectedNode.item);
			});
			this._getAdvancedLinks();

			this.newwindow_checkbox = new epages.widget.FormElement({}, this.newwindow_checkbox).elementNode;
		},

		onSelectPage: function(/*object*/data) {
			var href = this.useSSL && data.webUrlSSL ? data.webUrlSSL : data.webUrl;
			if(this.useAbsolutePath == false)
				if (href.match(/(\?.*)$/g)) href = RegExp.$1;
			this.url_input.value = href;
			if (this.linktext_div.style.display != 'none') this.linktext_input.value = data.title;
		},

		// called when clicking "Apply", inserts/updates the link in the editor
		onApplyClick: function() {
			this.hide();
			var href = this.url_input.value;
			var newWindow = this.newwindow_checkbox.checked;
			var linkText = this.linktext_input.value;
			if (linkText == "") linkText = href;
			if (this.parentLink != null) {
				this.parentLink.href = href;
				this.parentLink.setAttribute("mce_href", href);
				if (newWindow) {
					this.parentLink.target = "_blank";
				} else {
					this.parentLink.target = "";
				}
				this.parentLink.innerHTML = linkText;
				epages.topDojo.publish('tinymce_windowmanager_open/changeContent',[tinyMCE.activeEditor.editorId]);
			} else {
				var html = '<a href="' + href + '" mce_href="' + href + '"';
				if (newWindow) html += ' target="_blank"';
				html += '>' + linkText + '<'+'/a>';
				//go back to saved bookmark
				tinyMCE.activeEditor.selection.moveToBookmark(tinymce.WindowManager.bookmark);
				this.tinyMCEInstance.execCommand("mceInsertContent", true, html);
			}
		},

		//open FileDialog and set openNode
		show: function() {
			this.tinyMCEInstance = tinyMCE.selectedInstance;
			this.parentLink = this.tinyMCEInstance.dom.getParent(this.tinyMCEInstance.selection.getNode(),"a");
			this.linktext_input.value = '';
			this.url_input.value = 'http://';
			this.newwindow_checkbox.checked = false;
			if (this.parentLink != null) {
				// parent node is an <a>
				this.linktext_div.style.display = 'none';
				this.linktext_input.value = this.parentLink.innerHTML;
				this.url_input.value = epages.html.getHref(this.parentLink);
				//IE adds base url to absolute Links so remove it again
				if(epages.Browser.engine == "MSIE"){
					var regExp = new RegExp(epages.vars.BaseUrl,"g");
					this.url_input.value = this.url_input.value.replace(regExp,"");
				}
				this.newwindow_checkbox.checked = (this.parentLink.target == '_blank');
			} else if (this.tinyMCEInstance.selection.isCollapsed()) {
				// nothing selected
				this.linktext_div.style.display = '';
			} else {
				// something selected
				this.linktext_input.value = this.tinyMCEInstance.selection.getContent();
				this.linktext_div.style.display = 'none';
			}

			//fill Anchor List
			var anchorNodes = this.tinyMCEInstance.dom.select('a.mceItemAnchor,img.mceItemAnchor');
			var childNodesLength = this.anchorSelect.childNodes.length;
			for(var i = 0; i < childNodesLength;i++){
				this.anchorSelect.removeChild(this.anchorSelect.lastChild);
			}
			var emptyOption = document.createElement('option');
			this.anchorSelect.appendChild(emptyOption);
			for(var i = 0; i < anchorNodes.length;i++){
				var elm = anchorNodes[i];
				var anchorNode = document.createElement('option');
				anchorNode.innerHTML = epages.format.slice(elm.name,50);
				if(this.useSSL && epages.vars.WebUrlSSL){
					anchorNode.value = epages.vars.WebUrlSSL+'#'+elm.name;
				}
				else{
					anchorNode.value = epages.vars.WebUrl+'#'+elm.name;
				}
				if(this.url_input.value == '#'+elm.name) anchorNode.selected = true;
				this.anchorSelect.appendChild(anchorNode);
			}
			if(anchorNodes.length)
				this.anchorContainerNode.style.display='';
			else
				this.anchorContainerNode.style.display='none';
			this.inherited("show", arguments);
		},

		hide: function() {
			this.inherited("hide", arguments);
			this.tree.blurNode();
		},

		_onChangeSelect:function(evt){
			//summary: private function to set links from select to main inputs
			for(var i = 0; i < evt.currentTarget.childNodes.length;i++){
				var elm = evt.currentTarget.childNodes[i];
				if(elm.selected == true){
					this.url_input.value = elm.value;
					if (this.linktext_div.style.display != 'none') this.linktext_input.value = elm.innerHTML;
				}
			}
		},

		_getAdvancedLinks: function(){
			var webUrl = this.useSSL && epages.vars.WebUrlSSL ? epages.vars.WebUrlSSL : epages.vars.WebUrl;
			var json = new epages.io.Json;
			var result = json.loadSync(this.url, {
				'ViewAction': 'JSONAdvancedLinks',
				'ObjectID':   this.siteId
			});
			if(!result.error){
				this._advancedLinks = result.data;
				for(var i = 0; i < this._advancedLinks.length;i++){
					var elm = this._advancedLinks[i];
					var option = document.createElement('option');
					if(this.useAbsolutePath && webUrl){
						var testRegEx = /^(.*)\?/g;
						// weburl contains query string?
						if(testRegEx.test(webUrl) == true) {
							testRegEx.exec(webUrl);
							option.value = RegExp.$1 + elm.Link;
						} else {
							option.value = webUrl + elm.Link;
						}
					}
					else{
						option.value = elm.Link;
					}
					option.innerHTML = elm.Alias;
					this.moreLinksSelectNode.appendChild(option);
				}
			}
		}

	}
);
