dojo.provide("epages.cartridges.de_epages.presentation.widget.MultipleUploadFlash");
dojo.require("epages.io.file");
dojo.require("epages.lang.uri");
dojo.require("epages.event");
dojo.require("epages.string");
dojo.require("epages.widget.Button");
dojo.require("epages.widget.Slides");
dojo.require("epages.uimessagehandler");
dojo.require("epages.widget.LocalizedWidget");

dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.MultipleUploadFlash",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public parameters
		 **/

		widgetsInTemplate:      true,
		debugMode:              window.djConfig.isDebug, 		// Boolean - toggle debug
		action:                 "", 												// String - url to that the contents will be posted
		baseAction:             epages.vars.BaseUrl, 				// String - base action url
		fileType:               "",													// String - file type (default is "all files") - see _fileAssociations for possible values
		multipleFiles:          false,											// Boolean - are multiple files allowed (or just one file)
		reloadAfterUpload:      false,											// Boolean - reloads the page after upload is finished
		// urls
		flashUrl:               dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', "templates/MultipleUploadFlash.swf") + "?" + String(Math.floor(Math.random()*9999)),
		templatePath:           dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', "templates/MultipleUploadFlash.html"),
		translationName:        dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', "templates/translation"),
		status:                 "ready",										// [readonly] String - Can be either "ready" while waiting or "uploading" while uploading the files

		/**
		 * public display properties
		 * -> preview mode can be activated by using img tag with src attribute
		 **/
		spriteName:             'fileupload',	// string - name of css sprite whitout prefix
		big:                    false,				// boolean - flag to show a big button
		button:                 true,					// boolean - flag to show button or icon
		previewWidth:           '100px',			// string - width of preview image
		previewHeight:          '100px',			// string - height of previewimage
		previewCachePrevention: 'false',			// boolean - append timestamp on preview image url

		// hash of additional form params
		formParams:             null,
		formElement:            "NewFile",

		objectId:               "", 		// String - object id for request

		directory:              "", // String - sub directory of object

		useMediaGallery:        true, // Boolean - if true, then all files are stored below the media gallery root, otherwise in the object's public path

		// small extra functions (passed as string / function / whatever - will be parsed in the right spot)
		onUploadStarted:        "",
		onUploadFinished:       "",

		useBaseUrlForHref:      false, // do not use current location.href. rebuild url instead

		/**
		 * private parameters
		 **/

		_iconPlain:             (epages.themeUrl('images') + "/plain.gif"), 		// String - icon path


		_filesToUpload:         0, 		// Integer - how many files selected

		_currentUploadIndex:    0, 		// Integer - current index of the upload progress

		_filesUploaded:         [], 	// [] - container of all respond objects


		_flashUpload:           null, // - nodes of upload fields

		// texts
		_progressText:          "",
		_errorHeadline:         "",
		_errorText:             "",
		_fileTypeTranslated:    "",
		_fileUploadText:        "",

		_errorFiles:            [],

		_errorResponseMessages: {
			_INTERAL_SERVER_ERROR:  "",
			_FILE_SIZE_LIMIT_ERROR: "",
			_FILE_SYSTEM_ERROR:     "",
			_PRODUCT_IMAGE_MAX_COUNT: ""
		},

		// file associations
		_fileAssociations:      {
			Icons: ["ico","cur"],
			Images: ["jpg","jpeg","gif","png"],
			Documents: ["pdf","doc","rtf","txt"],
			Sound: ["mp3","mp4","wma","wav","flac","ogg"],
			Video: ["avi","wmv","flv","mpg","mpeg","mp4"]
		},

		_imageSrc:              "",
		_originalAction: '',

		_getFlashUpload: function() {
			if(!$("_fileUploadFlash")) {
				var uploadContainer = document.createElement("ins");
				uploadContainer.style.cssText = "position:absolute;z-index:99999;left:0;top:0";
				uploadContainer.innerHTML = "<object style='filter:alpha(opacity=0);opacity:0.0001' wmode='opaque' id='_fileUploadFlash' width='1' height='1' type='application/x-shockwave-flash' data='" + this.flashUrl + "'><param name='movie' value='" + this.flashUrl + "'/><param name='allowscriptaccess' value='always'/><param name='wmode' value='opaque'/></object>";
				dojo.body().appendChild(uploadContainer);
			}
			this._flashUpload = $("_fileUploadFlash");

			// bitchy firefox won't render our flash unless it permanently stays inside of the viewport
			dojo.connect(window, "scroll", this, function() {
				with(this._flashUpload.parentNode.style) {
					top = dojo.body().parentNode.scrollTop + "px";
					left = dojo.body().parentNode.scrollLeft + "px";
				}
			});
		},

		_setProgressMessage: function() {
			top.dojo.publish("uimessage/changeBusy", ["MultipleUploadFlash", "<b>" + this._progressText + "</b><div class='AlignCenter'>" + (this._currentUploadIndex + 1 || 1) + " / " + this._filesToUpload]) + "</div>";
		},

		_setUploadStatus: function() {
			this._currentUploadIndex++;
			if(this._filesToUpload == this._currentUploadIndex) {
				this._onUploadFinished();
			}
		},

		_onSelect: function(selectedFiles) {if(this.debugMode) {console.debug("Selected " + selectedFiles + " file(s) - uploading now")}

			eval(this.onUploadStarted)

			this._filesToUpload = new Number(selectedFiles);
			this.status = "uploading";

			top.dojo.publish("uimessage/startBusy", ["MultipleUploadFlash", ""]);

			this._setProgressMessage();

		},

		_onOpen: function(openedFile) {if(this.debugMode) {console.debug("Uploading: " + openedFile)}

		},

		_onError: function(errorType, errorFile, errorMessage) {if(this.debugMode) {console.warn(errorType + ": " + errorFile)}
			//errorType:
			// one of those: 
			//	|HTTP 500 - Internal Server Error (not specified)
			//	|HTTP 413 - Filesize too large
			//	|IO       - There was an error on retrieving the file from the clients file system
			//	|Error    - The server has sent an error with a specific error message (HTTP 200 is returned) 
			//  |           (e.g. an ImageMagick image processing error)
			
			if(typeof errorMessage == "undefined" || errorMessage == "") {
				switch(errorType) {
					case "HTTP 500":
						errorMessage = this._errorResponseMessages._INTERAL_SERVER_ERROR;
						break;
					case "HTTP 413":
						errorMessage = this._errorResponseMessages._FILE_SIZE_LIMIT_ERROR;
						break;
					case "IO":
						errorMessage = this._errorResponseMessages._FILE_SYSTEM_ERROR;
						break;
					case "PRODUCT_IMAGE_MAX_COUNT":
					errorMessage = this._errorResponseMessages._PRODUCT_IMAGE_MAX_COUNT;
					break;
					default:
						errorMessage = "";
				}
			}

			this._errorFiles.push({errorType: errorType, errorFile: errorFile, errorMessage: errorMessage});

			this._filesUploaded.push("error");

			this._setUploadStatus();
		},

		_onComplete: function(completedFile, respondData) {if(this.debugMode) {console.debug("Completed: " + completedFile + " with the following response:");console.debug(respondData);}
			this._setProgressMessage();

			if(respondData.Errors) {
				this._onError(respondData.Errors[0].Reason, completedFile, respondData.Errors[0].Message);
			}else {
				this._filesUploaded.push(respondData);
				this._setUploadStatus();
				if(this._imageSrc) {
					this.imgNode.src = respondData.uploadedFiles[0];
					this._imageSrc = this.imgNode.src;
				}
			}
		},

		_onUploadFinished: function() {if(this.debugMode) {console.debug("Upload finished.")}

			if(this._errorFiles.length) {

				var errorDialog = {
					title: this._errorHeadline,
					message: this._errorText,
					files: ""
				}

				for(var i = 0;i < this._errorFiles.length; i++) {
					errorDialog.files += "<div><b>" + this._errorFiles[i].errorFile + ":</b> " + this._errorFiles[i].errorMessage + "</div>";
				}

				top.dojo.publish("uimessage/show", [errorDialog.message, errorDialog.files, "Dialog" , {titleBar: this._errorHeadline, typeClass: "Error", sizeClass:"Large"}])

				dojo.connect($$("uimessage_dialog").innerButtonBarNode.getElementsByTagName("span")[0], "click", this, "_resetUploadValues");
				dojo.connect($$("uimessage_dialog").closeButtonNode, "click", this, "_resetUploadValues");

			}else if(this._filesUploaded[0].uploadedFiles) {

				var activeUploadedImage = this._filesUploaded[0].uploadedFiles[0];

				dojo.publish(this.id + "/onUploadFinished", [{ result: this._filesUploaded }])
				dojo.publish("MultipleUploadFlash/onUploadFinished", [{ result: this._filesUploaded }])
				eval(this.onUploadFinished);

				var date = new Date();
				var cacheAppendix = (this.previewCachePrevention) ? "?CachePrevention="+date.getTime() : "";
				if(this._imageSrc) {
					this.displayNode.addImage({image: activeUploadedImage + cacheAppendix}, true);
				}

				this._resetUploadValues();

			}else {
				this.reloadAfterUpload = true;
				this._resetUploadValues();
			}

			top.dojo.publish("uimessage/stopBusy", ["MultipleUploadFlash"]);
			this.status = "ready";

		},

		_resetUploadValues: function() {
			if(this.reloadAfterUpload) {
				var dialogArea = actualDialogArea ? "DialogArea=" + actualDialogArea : "";
				if(location.href.search(/Monitor/) != -1 && epages.vars.BaseUrl && epages.vars.ViewAction && epages.vars.ObjectID){
					var newHref = epages.vars.BaseUrl + '?ViewAction=' + epages.vars.ViewAction + '&ObjectID=' + epages.vars.ObjectID;
					if(dialogArea == ''){
						location.href = newHref;
					}
					else{
						location.href = newHref + '&'+dialogArea;
					}
				}
				else{
					if(location.href.search(/DialogArea/) != -1){
						var newLocation;
						if (this.useBaseUrlForHref) {
							newLocation = epages.vars.BaseUrl + '?ViewAction=' + epages.vars.ViewAction + '&ObjectID=' + epages.vars.ObjectID;
						} else {
							newLocation = location.href;
						}
						for(var i = 0; i < epagesDialog.areaName.length; i++){
							var regEx = new RegExp('DialogArea='+epagesDialog.areaName[i]);
							newLocation = newLocation.replace(regEx,dialogArea);
						}
						location.href = newLocation;
					}
					else{
						if(dialogArea == ''){
							location.href = location.href;
						}else {
							location.href = location.href + '&'+dialogArea;
						}
					}
				}
			}

			this._currentUploadIndex = 0;
			this._filesUploaded = [];
			this._errorFiles = [];
		},

		_onExternalMouseUp: function() {
			// summary: this function is called by flash (event bubble)
			this._resetUploadFlashPosition();
			if(this._flashUpload.releaseCapture) {this._flashUpload.releaseCapture()}
		},

		_setUploadFlashPosition: function(evt) {
			with(this._flashUpload) {
				with(parentNode.style) {
					top = new epages.html.Element(evt.currentTarget).getAbsolutePosition(dojo.body()).y + "px";
					left = new epages.html.Element(evt.currentTarget).getAbsolutePosition(dojo.body()).x + "px";
				}
				width = evt.currentTarget.offsetWidth + 10;
				height = evt.currentTarget.offsetHeight;
			}
		},

		_resetUploadFlashPosition: function() {
			with(this._flashUpload) {
				with(parentNode.style) {
					top = "0";
					left = "0";
				}
				width = 1;
				height = 1;
			}
		},

		uploadFiles: function(evt) {
			if(this._flashUpload.upload) {
				if(this._flashUpload.setCapture) {this._flashUpload.setCapture()}
				this._flashUpload.upload({
					action: this.action,
					widgetId: this.domNode.getAttribute("widgetid"),
					formElement: this.formElement,
					fileType: this._fileTypeTranslated,
					fileAssociations: this._fileAssociations[this.fileType],
					multipleFiles: this.multipleFiles
				});
				// since as of fp10 flash does not allow us to show the file open dialog
				// without a (flash-)user interaction anymore, we have to immediately place
				// the flash object underneath the cursor in order to catch the "mouseup" event
				// ...clickjacking
				this._setUploadFlashPosition(evt);
			}
		},

		removeImage: function() {
			// summary:
			//    set empty image (hide the current image)
			this.displayNode.addImage({image: epages.vars.IconsRoot + "/general_img_transparentpixel.gif"}, true);
		},

		getIndex: function() {
			// summary:
			//    returns the current position of the file queue
			// returns:
			//    position
			return this._currentUploadIndex; // Integer
		},

		getStatus: function() {
			// summary:
			//    returns the current status => uploading|ready
			// returns:
			//    status
			return this.status; // String
		},

		setDirectory: function(/*String*/ directory) {
			// summary:
			//    sets the directory parameter of the request
			// directory:
			//    directory parameter
			this.formParams.Directory = directory;
			this.directory = directory;

			var params = epages.lang.uri.splitQueryString(this._originalAction);
			params.UseMediaGallery = this.useMediaGallery ? '1' : '0';

			params = $H(dojo.mixin(this.formParams, params)).toQueryString();
			this.action = this.baseAction + "?" + params;
			if(this._flashUpload.upload){
				this._flashUpload.upload({
					'action': this.action,
					'widgetId': this.domNode.getAttribute("widgetid"),
					'formElement': this.formElement,
					'fileType': this._fileTypeTranslated,
					'fileAssociations': this._fileAssociations[this.fileType],
					'multipleFiles': this.multipleFiles
				});
			}
		},

		constructor: function() {
			this.formParams = {
				'ViewAction':   'JSONViewResponse',
				'ChangeAction': 'UploadFiles',
				'ObjectID':     epages.vars.SiteID
			};
			this._filesUploaded = [];
			this._errorFiles = [];
		},

		postMixInProperties: function() {
			this.inherited('postMixInProperties', arguments);
			if(!epages.vars.BaseUrl) {
				console.warn("epages.vars.BaseUrl not defined in "+ this.declaredClass);
			}
			this.baseAction= this.baseAction.replace(/https:/, "http:") + ";SessionID=" + epages.vars.SessionID;

			// convert from string to boolean
			this.useMediaGallery = epages.string.toBoolean(this.useMediaGallery);
			this.big = epages.string.toBoolean(this.big);
			this.button = epages.string.toBoolean(this.button);
			this.debugMode = epages.string.toBoolean(this.debugMode);
			this.multipleFiles = epages.string.toBoolean(this.multipleFiles);
			this.reloadAfterUpload = epages.string.toBoolean(this.reloadAfterUpload);
			this.previewCachePrevention = epages.string.toBoolean(this.previewCachePrevention);
			this.useBaseUrlForHref = epages.string.toBoolean(this.useBaseUrlForHref);

			this._fileUploadText = this.multipleFiles ? this.translate("FileUploadMultiple") : this.translate("FileUploadSingle");
			this._progressText = this.translate("FileUploadInProgress");
			this._errorHeadline = this.translate("FileUploadError");
			this._errorText = this.translate("UploadErrorFiles");
			this._fileTypeTranslated = this.translate(this.fileType);

			with(this._errorResponseMessages) {
				_INTERAL_SERVER_ERROR = this.translate("InternalServerError");
				_FILE_SIZE_LIMIT_ERROR = this.translate("FileSizeLimitError") + " (" + this.translate("MaxFileSize") + ": " + Math.round(epages.vars.MaxContentLength / 1024) + " MByte)";
				_FILE_SYSTEM_ERROR = this.translate("FileSystemError");
				_PRODUCT_IMAGE_MAX_COUNT = this.translate("TooManyFiles");
			}

			if(this.srcNodeRef.tagName.toLowerCase() == "img") {
				this._imageSrc = this.srcNodeRef.src;
			} else if(this.srcNodeRef.src) {
				console.warn('use img tag to enable image preview');
			}
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);

			this._fileAssociations.Media = this._fileAssociations.Sound.concat(this._fileAssociations.Video);

			if(this.objectId != "") {this.formParams.ObjectID = this.objectId}
			if(this.directory != "") {this.formParams.Directory = this.directory}

			this._originalAction = this.action;
			var params = epages.lang.uri.splitQueryString(this.action);
			params.UseMediaGallery = this.useMediaGallery ? '1' : '0';
			params = $H(dojo.mixin(this.formParams, params)).toQueryString();

			this.action = this.baseAction + "?" + params;

			this._getFlashUpload();

			this.domNode.style.fontSize = "0";

			// Safari on Mac won't let us clickjack the user
			var mouseEvent = (navigator.appVersion.match("Macintosh") && navigator.appVersion.match("Safari")) ? "mouseover" : "mousedown";
			if(this.srcNodeRef.tagName.toLowerCase() == "img") {						// displayoption with preview
				if(this.button) {
					this.domNode.getElementsByTagName("b")[0].parentNode.className += " ResetForImage";
					this.connect(this.domNode.getElementsByTagName("b")[0], mouseEvent, this.uploadFiles);
				} else {
					this.domNode.getElementsByTagName("b")[0].parentNode.className += " ResetForImage";
					this.domNode.getElementsByTagName("b")[0].style.display="none";
					dojo.removeClass(this.previewIconNode, "HideElement");
					this.connect(this.previewIconNode, mouseEvent, this.uploadFiles);
				}
			}else if(this.big){																							// displayoption big icon / button
				if(this.button) {
					this.domNode.getElementsByTagName("u")[1].parentNode.parentNode.className = "";
					this.connect(this.domNode.getElementsByTagName("u")[1].parentNode, mouseEvent, this.uploadFiles);
				}else {
					this.bigIcon.parentNode.className += " ResetForImage MultipleUploadBigButton";
					this.connect(this.bigIcon, mouseEvent, this.uploadFiles);
				}
			}else {																													// displayoption small icon / button
				if(this.button) {
					this.domNode.getElementsByTagName("u")[0].parentNode.parentNode.className = "";
					this.connect(this.domNode.getElementsByTagName("u")[0].parentNode, mouseEvent, this.uploadFiles);
				}else {
					// small image upload (no need for that at this time)
				}
			}
		}
	}
);
