/*
	Copyright (c) 2006-2007, epages Software GmbH
	All Rights Reserved.
*/
dojo.provide("epages.cartridges.de_epages.presentation.widget.UploadImage");
dojo.require("epages.widget.DeleteFileOnServer");
dojo.require("epages.widget.Tooltip");
dojo.require("epages.widget.FormElement");
epages.require('ep_shop_upload', 'epages.uploader');
dojo.require("epages.localize");
dojo.require("epages.event");
dojo.require("epages.format");
dojo.require("epages.widget.Slides");
dojo.require("epages.io.json");

dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.UploadImage",
	[epages.widget.DeleteFileOnServer, epages.widget.LocalizedWidget ],
	{
		imageWidth :        '',
		imageHeight:        '',
		scaleWidth :        '',
		scaleHeight:        '',
		scaleQuality:       '',
		uploadAction:       'UploadFiles',
		fileType:           'Images',
		infoText:           '',
		scaleText:          '',
		doScaleImage:       '1',
		onUploaded:         '',
		templateString:     '',
		templatePath:       dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget','templates/UploadImage.html'),
		translationName:    dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget','templates/translation'),
		widgetsInTemplate:  true,
		useMediaGallery:    false,
		fileAttribute:      '',
		fileInputNode:      null,
		fileInputName:      '',
		fileInputValue:     '',
		uploadInputName:    'NewFile',
		scaleCheckboxName:  'ResizeImageLarge',
		showDeleteNode:     true,
		objectId:						epages.vars.ObjectID || '',
		deleteObjectId:			this.objectId || epages.vars.ObjectID || '',
		saveAfterUpload:    false,
		url:                '?',
		saveAction:         'Save',
		saveParameters:     undefined,
		reloadPage:					false,

		headlineConfirm:    epages.io.dictionary.get('HeadLineDeleteFile'), // 'Moechten Sie diese Datei wirklich loeschen ?',
		titleConfirm:       epages.io.dictionary.get('TitleDeleteFile'), // 'Datei loeschen',
		altDelete:          epages.io.dictionary.get('TitleDeleteFile'), //'Datei loeschen',

		setUploadUrl: function () {

			// build url
			this.uploadUrl = '?ChangeAction='+ this.uploadAction
										 + '&ObjectID=' + this.objectId
										 + '&Image=' + this.fileAttribute
										 + '&UseMediaGallery=' + (this.useMediaGallery ? '1' : '0');
			if (this.doScaleImage) {
				if (this.scaleWidth != '') this.uploadUrl += '&Width='+ this.scaleWidth;
				if (this.scaleHeight != '') this.uploadUrl += '&Height='+ this.scaleHeight;
				if (this.scaleQuality != '') this.uploadUrl += '&Quality='+ this.scaleQuality;
			}
			//this.uploadAppletNode.action = this.uploadUrl;
			dojo.connect(this.uploadAppletNode, 'onclick', this, function() {
				epages.Uploader.open({
					multiple : false,
					action : this.uploadUrl,
					fileType : this.fileType,
					reloadPage : this.reloadPage,
					id : this.uploadAppletNode.id
				});
			});
		},

		postMixInProperties: function () {
			this.inherited("postMixInProperties", arguments);

			this.doScaleImage = epages.string.toBoolean(this.doScaleImage);
			this.useMediaGallery = epages.string.toBoolean(this.useMediaGallery);
			this.fileName = epages.format.slice(this._getFileName(this.fileName), 25);
			this.showDeleteNode = epages.string.toBoolean(this.showDeleteNode);
			if (!this.fileAttribute && this.fileInputName) {
				this.fileAttribute = this.fileInputName;
			}

			// build info text
			this.infoText = '';
			if (this.fileSize   != '') {
				this.infoText = epages.localize.formatBytes(this.fileSize, 0);
			}
			if (this.imageWidth != '' && this.imageHeight != '') {
				this.infoText += ' (' + this.imageWidth + ' &times; ' + this.imageHeight + 'px)';
			}

			// build scale text
			if (!this.scaleText) {
				this.scaleText = this.translate('ScaleImage');
			}
			if (this.scaleWidth != '' && this.scaleHeight != '') {
				this.scaleText += " <span class='ShowElement AdditionalInfo' style='padding-left:22px'>(" + this.translate("maxWidth") + " " + this.scaleWidth + "px &times; " + this.translate("maxHeight") +" "+ this.scaleHeight + "px)</span>";
			} else if(this.scaleWidth) {
				this.scaleText += " <span class='ShowElement AdditionalInfo' style='padding-left:22px'>(" + this.translate("Width") + ": " + this.scaleWidth + "px)</span>";
			} else if(this.scaleHeight) {
				this.scaleText += " <span class='ShowElement AdditionalInfo' style='padding-left:22px'>(" + this.translate("Height") + ": " + this.scaleHeight + "px)</span>";
			}
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);
			if (!this.scaleWidth && !this.scaleHeight) {
				this.scaleImageNode.style.display = 'none';
			}
			if (!this.infoText) {
				this.infoNode.style.display = 'none';
			}
			if (!this.showDeleteNode || !this.filePath || !this.fileName) {
				this.deleteNode.domNode.style.display = 'none';
			}

			this.scaleCheckBoxNode = new epages.widget.FormElement({}, this.scaleCheckBoxNode).elementNode;
			if (this.doScaleImage) {
				this.scaleCheckBoxNode.checked = true;
			}
			dojo.connect(this.scaleCheckBoxNode, "onclick", this, "toggleDoScale");

			if (this.fileInputName) {
				this.fileInputNode = this.domNode.ownerDocument.createElement('input');
				this.fileInputNode.type = 'hidden';
				this.fileInputNode.name = this.fileInputName;
				this.fileInputNode.value = this.fileInputValue;
				this.domNode.appendChild(this.fileInputNode);
				if(this.saveAfterUpload){
					dojo.addClass(this.fileInputNode, 'NoButtonTrigger');
				}
			}

			// set id for uploader
			dojo.attr(this.uploadAppletNode, 'id', this.id+'_uploader');
			dojo.subscribe(this.uploadAppletNode.id + "/onUploadFinished", this, 'onUpload');
			if (this.showDeleteNode) {
				this.deleteNode.onSuccess = dojo.hitch(this, 'onDelete');
			}

			// build url
			this.setUploadUrl();
		},

		onOpen: function (evt) {
			dojo.stopEvent(evt);
			dojo.require("epages.epages");
			if (this.onPreview == '') {
				openWindow(this.filePath, '', 'open');
				return false;
			}
			return eval(this.onPreview);
		},

		toggleDoScale:function (evt) {
			this.doScaleImage = !this.doScaleImage;
			this.setUploadUrl();
		},

		onUpload: function (opt) {
			if (this.onUploaded != '') {
				eval(this.onUploaded);
			}
			var image = opt.uploadedFiles[0].toString();
			if(image) {
				this.displayNode.addImage({image: image}, true);
			}
			if (this.fileInputNode) {
				this.fileInputValue = opt.uploadedObjectFiles[0] ? opt.uploadedObjectFiles[0] : image;
				this.fileInputNode.value = this.fileInputValue;
				epages.event.fire(this.fileInputNode, 'change');
			}
			var imageInfo = opt.imageInfo ? opt.imageInfo[0] : null;
			if (imageInfo) {
				this.filePath = image;
				this.fileName = imageInfo.FileName;
				this.nameNode.innerHTML = imageInfo.FileName;
				this.nameNode.href = image;
				this.infoNode.innerHTML = epages.localize.formatBytes(imageInfo.Size, 0) + ' (' + imageInfo.Width + ' &times; ' + imageInfo.Height +'px)';
				this.infoNode.style.display = '';
				// update file in deletenode
				if(this.deleteNode) {
					this.deleteNode.filePath=image;
        	this.deleteNode.fileName=imageInfo.FileName;
        }
			} else {
				this.fileName = this._getFileName(image);
				this.nameNode.innerHTML = this.fileName;
				// update file in deletenode
				if(this.deleteNode) {
					this.deleteNode.filePath = this._getFilePath(image);
        	this.deleteNode.fileName = this.fileName;
        }
			}
			this.nameNode.style.display = '';
			this.infoNode.style.display = '';
			if (this.showDeleteNode) {
				this.deleteNode.domNode.style.display = '';
			}
			if(this.saveAfterUpload){
				this._saveAfterUpload();
			}
			dojo.publish(this.id + '/upload');
		},

		onDelete: function() {
			this.nameNode.style.display = 'none';
			this.infoNode.style.display = 'none';
			this.removeImage();
			if (this.fileInputNode) {
				this.fileInputValue = '';
				this.fileInputNode.value = '';
				epages.event.fire(this.fileInputNode, 'change');
			}
			dojo.publish(this.id + '/delete');
		},

		removeImage: function() {
			// summary:
			//    set empty image (hide the current image)
			this.displayNode.addImage({image: epages.vars.IconsRoot + "/general_img_transparentpixel.gif"}, true);
		},

		_getFileName: function(path) {
			return path.split('/').pop();
		},

		_getFilePath: function(path) {
			path = path.split('/').pop();
			return path.join('/');
		},

		_saveAfterUpload: function(){
			//summary: save Attribute direct after Upload
			var json = new epages.io.Json;
			var parameters = {
				'ViewAction': 'JSONViewResponse',
				'ObjectID':   this.objectId,
				'ChangeAction':    this.saveAction
			};
			parameters[this.fileInputName] = this.fileInputValue;
			if(this.saveParameters){
				dojo.mixin(parameters,this.saveParameters);
			}
			json.loadAsync(this.url,
			dojo.hitch(this,function(result){
				if(!result.error){
					this.deleteNode.fileName = this.fileName;
				}
			}),parameters);
		}

	}
);
