use Test::Simple tests => 9;
use strict;
use Time::HiRes qw (time);
use DE_EPAGES::Core::API::Script qw ( RunScript );
use DE_EPAGES::Core::API::File qw ( GetFileContent WriteFile );
use DE_EPAGES::Presentation::API::TLE::IncludeTemplateHandler qw ( _ReplaceGadgets );

sub Main {
    ##no critic qw(ProtectPrivateSubs)
    my $Dir = "IncludeTemplateHandler.Gadgets/";
    for (my $i = 1; $i <= 9; $i++) {
        my $Source = "$i.src.txt";
        my $Target = "$i.txt";
        my $SourceString = ${GetFileContent($Dir.$Source)};
        my $Time0 = time;
        my $TargetString = DE_EPAGES::Presentation::API::TLE::IncludeTemplateHandler::_ReplaceGadgets($SourceString);
        my $TimeDiff = time - $Time0;
        my $ok = $TargetString eq ${GetFileContent($Dir.$Target)};
        ok($ok, sprintf( "checking file %s (%.5f s)", $Source, $TimeDiff ));
        if( !$ok ) {
            WriteFile( "$Dir$i.out.txt", \$TargetString );
        }
    }
}

RunScript(Sub=>\&Main,Debug=>1);
