/**
 * $Id: editor_template.js,v 1.24.2.1 2010/08/23 14:17:01 bbaum Exp $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2008, Moxiecode Systems AB, All rights reserved.
 */

(function() {
	var DOM = tinymce.DOM, Event = tinymce.dom.Event, extend = tinymce.extend, each = tinymce.each, Cookie = tinymce.util.Cookie, lastExtID;

	// Tell it to load theme specific language pack(s)
	tinymce.ThemeManager.requireLangPack('inline');

	// overload advanced theme
	tinymce.ThemeManager.load('advanced', 'themes/advanced/editor_template' + tinymce.suffix + '.js', function() {

		tinymce.create('tinymce.themes.InlineTheme:tinymce.themes.AdvancedTheme', {

			init : function(ed, url) {
				var t = this, s;

				t.editor = ed;

				ed.settings = t.settings = extend({
					// clear buttons
					theme_advanced_buttons1: "",
					theme_advanced_buttons2: "",
					theme_advanced_buttons3: "",
					theme_advanced_layout_manager: 'SimpleLayout',
					content_editable: false
				}, ed.settings);

				this.parent(ed, url);
			},

			execCommand : function(cmd, ui, val) {
				var f = this['_' + cmd];

				if (f) {
					f.call(this, ui, val);
					return true;
				}

				return false;
			},

			renderUI : function(o) {
				var n, ic, tb, t = this, ed = t.editor, s = t.settings, sc, p, nl;

				n = p = DOM.create('div', {id : ed.id + '_parent', 'class' : 'mceEditor ' + ed.settings.skin + 'Skin'});

				if (!DOM.boxModel)
					n = DOM.add(n, 'div', {'class' : 'mceOldBoxModel'});

				n.className += ' mceIframeContainer';
				sc = ic = n;
				ed.editorContainer =  n;
				n = o.targetNode;

				DOM.insertAfter(p, n);

				if (!ed.getParam('accessibility_focus') || ed.getParam('tab_focus'))
					Event.add(DOM.add(p, 'a', {href : '#'}, '<!-- IE -->'), 'focus', function() {tinyMCE.get(ed.id).focus();});

				// focus after rendering or showing
				dojo.connect(ed, 'show', dojo.hitch(this, function() {
					this._resizeEditor(ed);
					ed.execCommand('SelectAll');
					ed.selection.collapse(true);
					ed.focus();
				}));
				ed.onInit.add(function(ed) {
					window.setTimeout(dojo.hitch(ed, 'show'), 1);
				});
				o.deltaHeight = 0;

				t.deltaHeight = o.deltaHeight;
				o.targetNode = null;

				return {
					iframeContainer : ic,
					editorContainer : ed.id + '_parent',
					sizeContainer : sc,
					deltaHeight : o.deltaHeight
				};
			},

			getInfo : function() {
				return {
					longname : 'Inline theme',
					author : 'ePages GmbH',
					authorurl : 'http://www.epages.eu',
					version : epages.version
				}
			},

			_nodeChanged : function(ed, cm, n, co) {
				this.parent(ed, cm, n, co);
				if (n.nodeName.toLowerCase() == 'img') {
					if (!DOM.getAttrib(n, 'mce_name').match(/mceItem|epItemContent/) &&
							!DOM.getAttrib(n, 'class').match(/mceItem|epItemContent/)) { 												// image element selected
							dojo.publish('tinymce_inline/buttonsChanged', [{
								advimage : 2,	// 0 = disabled, 1 = normal (can insert item), 2 = active (item selected - edit)
								advmedia : 0	// 0 = disabled, 1 = normal (can insert item), 2 = active (item selected - edit)
							},ed]);

					} else if(!DOM.getAttrib(n, 'mce_name').match(/epItemContent/) &&
										!DOM.getAttrib(n, 'class').match(/epItemContent/) &&
										(DOM.getAttrib(n, 'class').match(/mceItemFlash/) ||
										DOM.getAttrib(n, 'class').match(/mceItemWindowsMedia/))) {										// media element selected (not gadget)
						dojo.publish('tinymce_inline/buttonsChanged', [{
							advimage : 0,	// 0 = disabled, 1 = normal (can insert item), 2 = active (item selected - edit)
							advmedia : 2	// 0 = disabled, 1 = normal (can insert item), 2 = active (item selected - edit)
						},ed]);
					} else {																																								// gadget (feed or configurable flashs) selected
						dojo.publish('tinymce_inline/buttonsChanged', [{
							advimage : 0,	// 0 = disabled, 1 = normal (can insert item), 2 = active (item selected - edit)
							advmedia : 0	// 0 = disabled, 1 = normal (can insert item), 2 = active (item selected - edit)
						},ed]);
					}
				} else {																																									// enable buttons
					dojo.publish('tinymce_inline/buttonsChanged', [{
						advimage : 1,	// 0 = disabled, 1 = normal (can insert item), 2 = active (item selected - edit)
						advmedia : 1	// 0 = disabled, 1 = normal (can insert item), 2 = active (item selected - edit)
					},ed]);
				}
				var p = ed.dom.getParent(n, 'td,th,caption');
				cm.setActive('table_update', n.nodeName === 'TABLE' || !!p);
				if (p && p.nodeName === 'CAPTION')
					p = null;
				cm.setDisabled('table_update', !p);
				//cm.setActive('advimage', false);
				//cm.setActive('media', false);
				//need Timeout to avoid layout errors when css propertys not ready
				window.setTimeout(dojo.hitch(this,function(){this._resizeEditor(ed);}),1);
				var fontFaceSelectArray = document.getElementsByName('inline_fontNameSelect');
				var fontSizeSelectArray = document.getElementsByName('inline_fontSizeSelect');
				var formatSelectArray = document.getElementsByName('inline_formatSelect');
				if(fontFaceSelectArray.length == fontSizeSelectArray.length
				&& fontFaceSelectArray.length == formatSelectArray.length
				&& fontSizeSelectArray.length == formatSelectArray.length){
					for(var j = 0; j < fontFaceSelectArray.length; j++){
						//set fontsize and font face
						var fontFaceSelect = fontFaceSelectArray[j];
						fontFaceSelect.selectedIndex = 0;
						var fontSizeSelect = fontSizeSelectArray[j];
						fontSizeSelect.selectedIndex = 0;
						//check if parentNode is font
						var fontNode = undefined;
						function checkParentNodes(node){
							if(!node.parentNode || node.parentNode.nodeName.toLowerCase() =='body' || node.parentNode.nodeName.toLowerCase() =='html') return null;
							if(node.parentNode.nodeName.toLowerCase() == 'font'){
								fontNode = node.parentNode;
							}
							else checkParentNodes(node.parentNode);
						};
						if(n.nodeName.toLowerCase() == 'font') fontNode = n;
						else checkParentNodes(n);
						if(fontNode){
							var fontFace = fontNode.getAttribute('face');
							var fontSize = fontNode.getAttribute('size');
							if(fontFace){
								for(var i = 0; i < fontFaceSelect.options.length;i++){
									if(fontFaceSelect.options[i].value == fontFace)
										fontFaceSelect.selectedIndex = fontFaceSelect.options[i].index;
								}
							}
							if(fontSize){
								for(var k = 0; k < fontSizeSelect.options.length;k++){
									if(fontSizeSelect.options[k].value == fontSize)
										fontSizeSelect.selectedIndex = fontSizeSelect.options[k].index;
								}
							}
						}
						//set font format
						var formatSelect = formatSelectArray[j];
						formatSelect.selectedIndex = 0;
						var fontFormat = n.nodeName.toLowerCase();
						if(fontFormat == 'font') fontFormat = n.parentNode.nodeName.toLowerCase();
						if(fontFormat){
							fontFormat = '<'+fontFormat+'>';
							for(var l = 0; l < formatSelect.options.length;l++){
								if(formatSelect.options[l].value == fontFormat)
									formatSelect.selectedIndex = formatSelect.options[l].index;
							}
						}
					}
				}
				cm.setDisabled('undo', !ed.undoManager.hasUndo() && !ed.typing);
				cm.setDisabled('redo', !ed.undoManager.hasRedo());
			},

			_resizeEditor: function(ed) {
				// resize Editor
				// taken from http://wiki.moxiecode.com/index.php/TinyMCE:Auto_resize_editor_box
				var editorID = ed.editorId, frame, doc, docHeight, frameHeight;
				frame = ed.contentAreaContainer.ownerDocument.getElementById(editorID+"_ifr");
				if ( frame != null ) {
					//get the document object
					if (frame.contentDocument) {
						doc = frame.contentDocument;
					} else if (frame.contentWindow) {
						doc = frame.contentWindow.document;
					} else if (frame.document) {
						doc = frame.document;
					}
					if(editorID != "RichTextEditor"){ // RichTextEditor -> editor in dialog
						frame.scrollTop = 0;
						if ( doc != null ) {
							//prevent the scrollbar from showing
							doc.body.style.overflow = "hidden";

							docHeight;
							frameHeight = parseInt(frame.style.height);

							//Firefox
							//if ( doc.height ) { docHeight = doc.height + 20; }
							//MSIE
							//else { docHeight = parseInt(doc.body.scrollHeight); }
							docHeight = parseInt(doc.getElementsByTagName('body')[0].scrollHeight);
							//MAKE BIGGER
							if ( docHeight != frameHeight ) { frame.style.height = (docHeight) + "px"; }
							//MAKE SMALLER
							//else if ( docHeight < frameHeight-0 ) { frame.style.height = (docHeight+31) + "px"; }
						}
					}
				}
			},

			_epeditlink: function(ui, params) {
				var useAbsolutePath = params.useAbsolutePath ? params.useAbsolutePath : false;
				var useSSL = params.useSSL ? params.useSSL : false;
				//save bookmark to put link on the correct place
				if(objectStore === undefined) {
					dojo.require("epages.cartridges.de_epages.presentation.widget.Objectstore");
					var objectStore = new epages.cartridges.de_epages.presentation.widget.Objectstore({
						jsId:      "objectStore",
						id:        "objectStore"
					});
				}
				tinymce.WindowManager.bookmark = tinyMCE.activeEditor.selection.getBookmark('simple');
				var Linkcreator = $$('Linkcreator');
				if (!Linkcreator) {
					dojo.require('epages.cartridges.de_epages.presentation.widget.Linkcreator');
					var node = document.createElement('span');
					dojo.body().appendChild(node);
					var Linkcreator = new epages.cartridges.de_epages.presentation.widget.Linkcreator({
						id: 'Linkcreator',
						label: '{EditLink}',
						useAbsolutePath: useAbsolutePath,
						useSSL: useSSL
					}, node);
				}
				Linkcreator.show();
				return true;
			},

			_mceCodeEditor : function(ui, val) {
				var ed = this.editor;
				ed.windowManager.open({
					url : tinymce.baseURL + '/themes/inline/source_editor.htm',
					inline : true,
					resizable : true,
					maximizable : true,
					width: 700,
					height: 370,
					title : '{EditHtml}',
					translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget','templates/translation'),
					buttons: [{
						label: '{Apply}',
						cssClass: 'Active',
						onclick: function() {
							window.mce_SourceEditor.saveContent();
							this._modalDialogWidget.close();
						}
					}, {
						label: '{Cancel}',
						onclick: function() {
							this._modalDialogWidget.close();
						}
					}]
				}, {
					theme_url : this.url
				});
			},

			_mceCharMap : function() {
			var ed = this.editor;

			ed.windowManager.open({
				url : tinymce.baseURL + '/themes/inline/charmap.htm',
				title : '{InsertSpecialChar}',
				translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget','templates/translation'),
				width : 550 + parseInt(ed.getLang('advanced.charmap_delta_width', 0)),
				height : 250 + parseInt(ed.getLang('advanced.charmap_delta_height', 0)),
				inline : true,
				buttons: [{
						label: '{Close}',
						onclick: function() {
							window.mce_Charmap.close();
							this._modalDialogWidget.close();
						}
					}]
			}, {
				theme_url : this.url
			});
		},

		_mceInsertAnchor : function(ui, v) {
			var ed = this.editor;

			ed.windowManager.open({
				url : tinymce.baseURL + '/themes/inline/anchor.htm',
				title : '{InsertAnchor}',
				translationName : dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget','templates/translation'),
				width : 350 + parseInt(ed.getLang('advanced.anchor_delta_width', 0)),
				height : 110 + parseInt(ed.getLang('advanced.anchor_delta_height', 0)),
				inline : true,
				buttons: [{
						label: '{Insert}',
						cssClass: 'Active',
						onclick: function() {
							window.mce_AnchorDialog.update();
							this._modalDialogWidget.close();
						}
					}, {
						label: '{Cancel}',
						onclick: function() {
							this._modalDialogWidget.close();
						}
					}]
			}, {
				theme_url : this.url
			});
		}

		});

		tinymce.ThemeManager.add('inline', tinymce.themes.InlineTheme);
	});

	epages.topDojo.extend(tinymce.WindowManager, {
		open: function(settings, parameters) {
			tinymce.WindowManager.parameters = parameters;
			//save Bookmark before opening an modal dialog to insert content in right place on ie
			tinymce.WindowManager.bookmark = tinyMCE.activeEditor.selection.getBookmark('simple');
			dojo.require("epages.widget.Modaldialog");
			dojo.require("dijit.layout.ContentPane");
			var dialogWidget = $$('tinymce_windowmanager_open');
			var doc = epages.topDojo.body().ownerDocument;
			if(settings.file && !settings.url) settings.url = settings.file;
			var options = {
				url: settings.url,
				width: 'auto',
				height: 'auto'
			}
			dojo.mixin(options, settings);
			if (dialogWidget == null) {
				dialogWidget = new epages.widget.Modaldialog({
					id: 'tinymce_windowmanager_open',
					options: options,
					buttons: options.buttons
				});
				doc.body.appendChild(dialogWidget.domNode);
			} else {
				dialogWidget.setupContent(options);
			}
			dialogWidget.show();
			dialogWidget.domNode.focus();
		}
	});

	epages.topDojo.extend(tinymce.dom.DOMUtils, {
		loadCSS : function(u) {
			//load CSS synchronous with dojo
			var t = this, d = this.doc;

			if (!u)
				u = '';

			each(u.split(','), function(u) {
				if(tinyMCE.settings.content_css != u)
					return;
				if (t.files[u])
					return;
				t.files[u] = true;
				if (epages.Browser.engine == 'MSIE' || epages.Browser.engine == 'WebKit') {
					t.add(t.select('head')[0], 'link', {rel : 'stylesheet', href : u});
				} else {
					var obj = dojo.xhrGet({
						url: u,
						handleAs: 'text',
						sync: true,
						load:function(data){
							var styletag = document.createElement('style');
							styletag.setAttribute('type','text/css');
							styletag.innerHTML = data;
							t.add(t.select('head')[0], styletag);
						}
					});
				}
			});
			return true;
		}
	});

	// button highlighting
	dojo.connect(tinymce.ControlManager.prototype, "setActive", function(controlName, set) {
		dojo.publish('tinyMCEControlManager/setActive',[controlName,set]);
		var control = $('mce_inline_' + controlName);
		if (control == null) return;
		control = $E(control.parentNode);

		if (set) {
			control.removeClassName('Normal');
			control.addClassName('Selected');
		} else {
			control.removeClassName('Selected');
			control.addClassName('Normal');
		}
	});

	dojo.connect(tinymce.ControlManager.prototype, "setDisabled", function(controlName, set) {
		var control = $('mce_inline_' + controlName);
		var controlDisabled = $('mce_inline_Disabled' + controlName);
		if (control == null) return;
		control = control.parentNode;

		// insert a dummy element, that looks like the original one to prevent click callback problems
		if (set) {
			if (!controlDisabled) {
				controlDisabled = control.cloneNode(true);
				controlDisabled.id = 'mce_inline_Disabled' + controlName;
				controlDisabled.onclick = null;
				// delete all ids
				for (var i = 0; i < controlDisabled.childNodes.length; i++) {
					if(controlDisabled.childNodes[i].id) {
						controlDisabled.childNodes[i].id = '';
					}
				}
				control.parentNode.insertBefore(controlDisabled, control);
			}
			controlDisabled.style.display = '';
			controlDisabled = $E(controlDisabled);
			controlDisabled.removeClassName('Normal');
			controlDisabled.addClassName('Disabled');
			control.style.display = 'none';
		} else {
			if (controlDisabled) {
				controlDisabled.style.display = 'none';
				controlDisabled = $E(controlDisabled);
				controlDisabled.removeClassName('Disabled');
				controlDisabled.addClassName('Normal');
			}
			control.style.display = '';
		}
	});

})();
