#!/bin/bash

EPAGES_PROJECT=${EPAGES_PROJECT:-$EPAGES_INSTALL_RUN_SCRIPT}
unset ETC_DEFAULT

if [ -z "$EPAGES_PROJECT" ] ; then
  [ -f /etc/sysconfig/epages6 ] &&  . /etc/sysconfig/epages6
  EPAGES_PROJECT=$EPAGES_INSTALL_RUN_SCRIPT
  if [ -z "$EPAGES_PROJECT" -a -f /etc/default/epages6 ] ; then
    EPAGES_PROJECT=epages6
  elif [ -z "$EPAGES_PROJECT" ] ; then
    PREFIX=$(rpm -q epages-common --qf '%{installprefix}' 2>/dev/null)
    if [ -f $PREFIX/etc/default/epages6 ] ; then
      ETC_DEFAULT=$PREFIX/etc/default/epages6
    elif [ $(ls /etc/default/epages6* 2>/dev/null | wc -l) -eq 1 ] ; then
      ETC_DEFAULT=$(ls /etc/default/epages6*)
    fi
  fi
fi

if [ -z "$ETC_DEFAULT" ] ; then
  EPAGES_PROJECT=${EPAGES_PROJECT:-epages6}
  ETC_DEFAULT=/etc/default/$EPAGES_PROJECT
fi

if [ ! -f "$ETC_DEFAULT" ] ; then
  echo -n "$0: " ; ls "$ETC_DEFAULT"
  exit 1
fi

. "$ETC_DEFAULT"

if [ ! -x "$HTTPD__SV" ] ; then
  echo "$0: \$HTTPD__SV not executable: $HTTPD__SV"
  exit 1
fi

pathmunge () {
  unset OUT
  OIFS=$IFS
  IFS=:
  for i in $1 ; do
    [ -z "$i" ] && continue
    [ -d "$i" ] || continue
    [ "${OUT%:$i:*}" = "${OUT#*:$i:}" ] || continue
    OUT="$OUT:$i"
  done
  IFS=$OIFS
  echo $OUT
}

case `uname -r` in
  2.6.16[.-]*) KERNEL=2.6.16s ;;
  2.6.18[.-]*) KERNEL=2.6.18r ;;
  2.6.27[.-]*) KERNEL=2.6.27s ;;
  2.6.32-*)    KERNEL=2.6.32r ;;
  2.6.32.*)    KERNEL=2.6.32s ;;
esac

export LD_LIBRARY_PATH=`pathmunge "$HTTPD_ROOT/lib:/lib:/usr/lib:/usr/X11R6/lib:$LD_LIBRARY_PATH"`
LD_LIBRARY_PATH=`pathmunge "$EPAGES_PERL/lib32/$KERNEL:$EPAGES_PERL/lib32/ssl:$EPAGES_PERL/bin:$LD_LIBRARY_PATH"`
unset pathmunge

exec $HTTPD__SV "$@"
